// Compiled by ClojureScript 0.0-2138
goog.provide('lt.object');
goog.require('cljs.core');
goog.require('lt.util.dom');
goog.require('lt.util.js');
goog.require('crate.binding');
goog.require('lt.util.js');
goog.require('lt.util.dom');
goog.require('lt.util.cljs');
goog.require('crate.core');
goog.require('lt.util.dom');
goog.require('clojure.string');
goog.require('lt.util.cljs');
goog.require('clojure.set');
goog.require('clojure.string');
goog.require('crate.binding');
goog.require('clojure.set');
goog.require('crate.core');
/**
* Counter to guarantee unique object ids
*/
lt.object.obj_id = cljs.core.atom.call(null,0);
/**
* Map of object ids to objects created by object/create
*/
lt.object.instances = cljs.core.atom.call(null,cljs.core.sorted_map.call(null));
/**
* Map of behavior names to behaviors created by macros/behavior
*/
lt.object.behaviors = cljs.core.atom.call(null,cljs.core.PersistentArrayMap.EMPTY);
/**
* Map of object template keys to template maps created by object/object*
*/
lt.object.object_defs = cljs.core.atom.call(null,cljs.core.PersistentArrayMap.EMPTY);
/**
* Map of tags to associated lists of behaviors
*/
lt.object.tags = cljs.core.atom.call(null,cljs.core.PersistentArrayMap.EMPTY);
/**
* Map of tags to dissociated lists of behaviors e.g. :-behavior
*/
lt.object.negated_tags = cljs.core.atom.call(null,cljs.core.PersistentArrayMap.EMPTY);
/**
* Metadata of current behavior set during raise and raise-reduce
*/
lt.object._STAR_behavior_meta_STAR_ = null;
lt.object.add = (function add(obj){return cljs.core.swap_BANG_.call(null,lt.object.object_defs,cljs.core.assoc,new cljs.core.Keyword("lt.object","type","lt.object/type",701613666).cljs$core$IFn$_invoke$arity$1(obj),obj);
});
lt.object.add_behavior = (function add_behavior(beh){return cljs.core.swap_BANG_.call(null,lt.object.behaviors,cljs.core.assoc,new cljs.core.Keyword(null,"name","name",1017277949).cljs$core$IFn$_invoke$arity$1(beh),beh);
});
/**
* Return id of given object
*/
lt.object.__GT_id = (function __GT_id(obj){if(crate.binding.deref_QMARK_.call(null,obj))
{return new cljs.core.Keyword("lt.object","id","lt.object/id",706431105).cljs$core$IFn$_invoke$arity$1(cljs.core.deref.call(null,obj));
} else
{return new cljs.core.Keyword("lt.object","id","lt.object/id",706431105).cljs$core$IFn$_invoke$arity$1(obj);
}
});
lt.object.__GT_behavior_name = (function __GT_behavior_name(beh){if(cljs.core.coll_QMARK_.call(null,beh))
{return cljs.core.first.call(null,beh);
} else
{return beh;
}
});
lt.object.__GT_behavior = (function __GT_behavior(beh){return cljs.core.deref.call(null,lt.object.behaviors).call(null,lt.object.__GT_behavior_name.call(null,beh));
});
lt.object.__GT_triggers = (function __GT_triggers(behs){var result = cljs.core.atom.call(null,cljs.core.transient$.call(null,cljs.core.PersistentArrayMap.EMPTY));var seq__14604_14616 = cljs.core.seq.call(null,behs);var chunk__14609_14617 = null;var count__14610_14618 = 0;var i__14611_14619 = 0;while(true){
if((i__14611_14619 < count__14610_14618))
{var beh_14620 = cljs.core._nth.call(null,chunk__14609_14617,i__14611_14619);var seq__14612_14621 = cljs.core.seq.call(null,new cljs.core.Keyword(null,"triggers","triggers",2516997421).cljs$core$IFn$_invoke$arity$1(lt.object.__GT_behavior.call(null,beh_14620)));var chunk__14613_14622 = null;var count__14614_14623 = 0;var i__14615_14624 = 0;while(true){
if((i__14615_14624 < count__14614_14623))
{var t_14625 = cljs.core._nth.call(null,chunk__14613_14622,i__14615_14624);cljs.core.swap_BANG_.call(null,result,cljs.core.assoc_BANG_,t_14625,cljs.core.conj.call(null,(function (){var or__3521__auto__ = cljs.core.get.call(null,cljs.core.deref.call(null,result),t_14625);if(cljs.core.truth_(or__3521__auto__))
{return or__3521__auto__;
} else
{return cljs.core.PersistentVector.EMPTY;
}
})(),beh_14620));
{
var G__14626 = seq__14612_14621;
var G__14627 = chunk__14613_14622;
var G__14628 = count__14614_14623;
var G__14629 = (i__14615_14624 + 1);
seq__14612_14621 = G__14626;
chunk__14613_14622 = G__14627;
count__14614_14623 = G__14628;
i__14615_14624 = G__14629;
continue;
}
} else
{var temp__4092__auto___14630 = cljs.core.seq.call(null,seq__14612_14621);if(temp__4092__auto___14630)
{var seq__14612_14631__$1 = temp__4092__auto___14630;if(cljs.core.chunked_seq_QMARK_.call(null,seq__14612_14631__$1))
{var c__4263__auto___14632 = cljs.core.chunk_first.call(null,seq__14612_14631__$1);{
var G__14633 = cljs.core.chunk_rest.call(null,seq__14612_14631__$1);
var G__14634 = c__4263__auto___14632;
var G__14635 = cljs.core.count.call(null,c__4263__auto___14632);
var G__14636 = 0;
seq__14612_14621 = G__14633;
chunk__14613_14622 = G__14634;
count__14614_14623 = G__14635;
i__14615_14624 = G__14636;
continue;
}
} else
{var t_14637 = cljs.core.first.call(null,seq__14612_14631__$1);cljs.core.swap_BANG_.call(null,result,cljs.core.assoc_BANG_,t_14637,cljs.core.conj.call(null,(function (){var or__3521__auto__ = cljs.core.get.call(null,cljs.core.deref.call(null,result),t_14637);if(cljs.core.truth_(or__3521__auto__))
{return or__3521__auto__;
} else
{return cljs.core.PersistentVector.EMPTY;
}
})(),beh_14620));
{
var G__14638 = cljs.core.next.call(null,seq__14612_14631__$1);
var G__14639 = null;
var G__14640 = 0;
var G__14641 = 0;
seq__14612_14621 = G__14638;
chunk__14613_14622 = G__14639;
count__14614_14623 = G__14640;
i__14615_14624 = G__14641;
continue;
}
}
} else
{}
}
break;
}
{
var G__14642 = seq__14604_14616;
var G__14643 = chunk__14609_14617;
var G__14644 = count__14610_14618;
var G__14645 = (i__14611_14619 + 1);
seq__14604_14616 = G__14642;
chunk__14609_14617 = G__14643;
count__14610_14618 = G__14644;
i__14611_14619 = G__14645;
continue;
}
} else
{var temp__4092__auto___14646 = cljs.core.seq.call(null,seq__14604_14616);if(temp__4092__auto___14646)
{var seq__14604_14647__$1 = temp__4092__auto___14646;if(cljs.core.chunked_seq_QMARK_.call(null,seq__14604_14647__$1))
{var c__4263__auto___14648 = cljs.core.chunk_first.call(null,seq__14604_14647__$1);{
var G__14649 = cljs.core.chunk_rest.call(null,seq__14604_14647__$1);
var G__14650 = c__4263__auto___14648;
var G__14651 = cljs.core.count.call(null,c__4263__auto___14648);
var G__14652 = 0;
seq__14604_14616 = G__14649;
chunk__14609_14617 = G__14650;
count__14610_14618 = G__14651;
i__14611_14619 = G__14652;
continue;
}
} else
{var beh_14653 = cljs.core.first.call(null,seq__14604_14647__$1);var seq__14605_14654 = cljs.core.seq.call(null,new cljs.core.Keyword(null,"triggers","triggers",2516997421).cljs$core$IFn$_invoke$arity$1(lt.object.__GT_behavior.call(null,beh_14653)));var chunk__14606_14655 = null;var count__14607_14656 = 0;var i__14608_14657 = 0;while(true){
if((i__14608_14657 < count__14607_14656))
{var t_14658 = cljs.core._nth.call(null,chunk__14606_14655,i__14608_14657);cljs.core.swap_BANG_.call(null,result,cljs.core.assoc_BANG_,t_14658,cljs.core.conj.call(null,(function (){var or__3521__auto__ = cljs.core.get.call(null,cljs.core.deref.call(null,result),t_14658);if(cljs.core.truth_(or__3521__auto__))
{return or__3521__auto__;
} else
{return cljs.core.PersistentVector.EMPTY;
}
})(),beh_14653));
{
var G__14659 = seq__14605_14654;
var G__14660 = chunk__14606_14655;
var G__14661 = count__14607_14656;
var G__14662 = (i__14608_14657 + 1);
seq__14605_14654 = G__14659;
chunk__14606_14655 = G__14660;
count__14607_14656 = G__14661;
i__14608_14657 = G__14662;
continue;
}
} else
{var temp__4092__auto___14663__$1 = cljs.core.seq.call(null,seq__14605_14654);if(temp__4092__auto___14663__$1)
{var seq__14605_14664__$1 = temp__4092__auto___14663__$1;if(cljs.core.chunked_seq_QMARK_.call(null,seq__14605_14664__$1))
{var c__4263__auto___14665 = cljs.core.chunk_first.call(null,seq__14605_14664__$1);{
var G__14666 = cljs.core.chunk_rest.call(null,seq__14605_14664__$1);
var G__14667 = c__4263__auto___14665;
var G__14668 = cljs.core.count.call(null,c__4263__auto___14665);
var G__14669 = 0;
seq__14605_14654 = G__14666;
chunk__14606_14655 = G__14667;
count__14607_14656 = G__14668;
i__14608_14657 = G__14669;
continue;
}
} else
{var t_14670 = cljs.core.first.call(null,seq__14605_14664__$1);cljs.core.swap_BANG_.call(null,result,cljs.core.assoc_BANG_,t_14670,cljs.core.conj.call(null,(function (){var or__3521__auto__ = cljs.core.get.call(null,cljs.core.deref.call(null,result),t_14670);if(cljs.core.truth_(or__3521__auto__))
{return or__3521__auto__;
} else
{return cljs.core.PersistentVector.EMPTY;
}
})(),beh_14653));
{
var G__14671 = cljs.core.next.call(null,seq__14605_14664__$1);
var G__14672 = null;
var G__14673 = 0;
var G__14674 = 0;
seq__14605_14654 = G__14671;
chunk__14606_14655 = G__14672;
count__14607_14656 = G__14673;
i__14608_14657 = G__14674;
continue;
}
}
} else
{}
}
break;
}
{
var G__14675 = cljs.core.next.call(null,seq__14604_14647__$1);
var G__14676 = null;
var G__14677 = 0;
var G__14678 = 0;
seq__14604_14616 = G__14675;
chunk__14609_14617 = G__14676;
count__14610_14618 = G__14677;
i__14611_14619 = G__14678;
continue;
}
}
} else
{}
}
break;
}
return cljs.core.persistent_BANG_.call(null,cljs.core.deref.call(null,result));
});
lt.object.specificity_sort = (function() {
var specificity_sort = null;
var specificity_sort__1 = (function (xs){return specificity_sort.call(null,xs,null);
});
var specificity_sort__2 = (function (xs,dir){var arr = [];var seq__14683_14687 = cljs.core.seq.call(null,xs);var chunk__14684_14688 = null;var count__14685_14689 = 0;var i__14686_14690 = 0;while(true){
if((i__14686_14690 < count__14685_14689))
{var x_14691 = cljs.core._nth.call(null,chunk__14684_14688,i__14686_14690);arr.push([[cljs.core.str(x_14691)].join('').split(".").length,[cljs.core.str(x_14691)].join(''),x_14691]);
{
var G__14692 = seq__14683_14687;
var G__14693 = chunk__14684_14688;
var G__14694 = count__14685_14689;
var G__14695 = (i__14686_14690 + 1);
seq__14683_14687 = G__14692;
chunk__14684_14688 = G__14693;
count__14685_14689 = G__14694;
i__14686_14690 = G__14695;
continue;
}
} else
{var temp__4092__auto___14696 = cljs.core.seq.call(null,seq__14683_14687);if(temp__4092__auto___14696)
{var seq__14683_14697__$1 = temp__4092__auto___14696;if(cljs.core.chunked_seq_QMARK_.call(null,seq__14683_14697__$1))
{var c__4263__auto___14698 = cljs.core.chunk_first.call(null,seq__14683_14697__$1);{
var G__14699 = cljs.core.chunk_rest.call(null,seq__14683_14697__$1);
var G__14700 = c__4263__auto___14698;
var G__14701 = cljs.core.count.call(null,c__4263__auto___14698);
var G__14702 = 0;
seq__14683_14687 = G__14699;
chunk__14684_14688 = G__14700;
count__14685_14689 = G__14701;
i__14686_14690 = G__14702;
continue;
}
} else
{var x_14703 = cljs.core.first.call(null,seq__14683_14697__$1);arr.push([[cljs.core.str(x_14703)].join('').split(".").length,[cljs.core.str(x_14703)].join(''),x_14703]);
{
var G__14704 = cljs.core.next.call(null,seq__14683_14697__$1);
var G__14705 = null;
var G__14706 = 0;
var G__14707 = 0;
seq__14683_14687 = G__14704;
chunk__14684_14688 = G__14705;
count__14685_14689 = G__14706;
i__14686_14690 = G__14707;
continue;
}
}
} else
{}
}
break;
}
arr.sort();
if(cljs.core.truth_(dir))
{} else
{arr.reverse();
}
var arr__3410__auto___14708 = arr;var i_14709 = 0;while(true){
if((i_14709 < arr__3410__auto___14708.length))
{(arr[i_14709] = (arr[i_14709][2]));
{
var G__14710 = (i_14709 + 1);
i_14709 = G__14710;
continue;
}
} else
{}
break;
}
return arr;
});
specificity_sort = function(xs,dir){
switch(arguments.length){
case 1:
return specificity_sort__1.call(this,xs);
case 2:
return specificity_sort__2.call(this,xs,dir);
}
throw(new Error('Invalid arity: ' + arguments.length));
};
specificity_sort.cljs$core$IFn$_invoke$arity$1 = specificity_sort__1;
specificity_sort.cljs$core$IFn$_invoke$arity$2 = specificity_sort__2;
return specificity_sort;
})()
;
lt.object.ts__GT_negations = (function ts__GT_negations(ts){var seen = (function (){var obj14718 = {};return obj14718;
})();var seq__14719_14723 = cljs.core.seq.call(null,cljs.core.apply.call(null,cljs.core.concat,cljs.core.map.call(null,cljs.core.deref.call(null,lt.object.negated_tags),ts)));var chunk__14720_14724 = null;var count__14721_14725 = 0;var i__14722_14726 = 0;while(true){
if((i__14722_14726 < count__14721_14725))
{var beh_14727 = cljs.core._nth.call(null,chunk__14720_14724,i__14722_14726);(seen[lt.object.__GT_behavior_name.call(null,beh_14727)] = true);
{
var G__14728 = seq__14719_14723;
var G__14729 = chunk__14720_14724;
var G__14730 = count__14721_14725;
var G__14731 = (i__14722_14726 + 1);
seq__14719_14723 = G__14728;
chunk__14720_14724 = G__14729;
count__14721_14725 = G__14730;
i__14722_14726 = G__14731;
continue;
}
} else
{var temp__4092__auto___14732 = cljs.core.seq.call(null,seq__14719_14723);if(temp__4092__auto___14732)
{var seq__14719_14733__$1 = temp__4092__auto___14732;if(cljs.core.chunked_seq_QMARK_.call(null,seq__14719_14733__$1))
{var c__4263__auto___14734 = cljs.core.chunk_first.call(null,seq__14719_14733__$1);{
var G__14735 = cljs.core.chunk_rest.call(null,seq__14719_14733__$1);
var G__14736 = c__4263__auto___14734;
var G__14737 = cljs.core.count.call(null,c__4263__auto___14734);
var G__14738 = 0;
seq__14719_14723 = G__14735;
chunk__14720_14724 = G__14736;
count__14721_14725 = G__14737;
i__14722_14726 = G__14738;
continue;
}
} else
{var beh_14739 = cljs.core.first.call(null,seq__14719_14733__$1);(seen[lt.object.__GT_behavior_name.call(null,beh_14739)] = true);
{
var G__14740 = cljs.core.next.call(null,seq__14719_14733__$1);
var G__14741 = null;
var G__14742 = 0;
var G__14743 = 0;
seq__14719_14723 = G__14740;
chunk__14720_14724 = G__14741;
count__14721_14725 = G__14742;
i__14722_14726 = G__14743;
continue;
}
}
} else
{}
}
break;
}
return seen;
});
lt.object.tags__GT_behaviors = (function tags__GT_behaviors(ts){var duped = cljs.core.apply.call(null,cljs.core.concat,cljs.core.map.call(null,cljs.core.deref.call(null,lt.object.tags),lt.object.specificity_sort.call(null,ts)));var de_duped = cljs.core.reduce.call(null,((function (duped){
return (function (res,cur){if(cljs.core.truth_((new cljs.core.Keyword(null,"seen","seen",1017430509).cljs$core$IFn$_invoke$arity$1(res)[lt.object.__GT_behavior_name.call(null,cur)])))
{return res;
} else
{var beh = lt.object.__GT_behavior.call(null,cur);if(cljs.core.truth_(new cljs.core.Keyword(null,"exclusive","exclusive",2700522000).cljs$core$IFn$_invoke$arity$1(beh)))
{if(cljs.core.coll_QMARK_.call(null,new cljs.core.Keyword(null,"exclusive","exclusive",2700522000).cljs$core$IFn$_invoke$arity$1(beh)))
{var seq__14748_14752 = cljs.core.seq.call(null,new cljs.core.Keyword(null,"exclusive","exclusive",2700522000).cljs$core$IFn$_invoke$arity$1(beh));var chunk__14749_14753 = null;var count__14750_14754 = 0;var i__14751_14755 = 0;while(true){
if((i__14751_14755 < count__14750_14754))
{var exclude_14756 = cljs.core._nth.call(null,chunk__14749_14753,i__14751_14755);(new cljs.core.Keyword(null,"seen","seen",1017430509).cljs$core$IFn$_invoke$arity$1(res)[exclude_14756] = true);
{
var G__14757 = seq__14748_14752;
var G__14758 = chunk__14749_14753;
var G__14759 = count__14750_14754;
var G__14760 = (i__14751_14755 + 1);
seq__14748_14752 = G__14757;
chunk__14749_14753 = G__14758;
count__14750_14754 = G__14759;
i__14751_14755 = G__14760;
continue;
}
} else
{var temp__4092__auto___14761 = cljs.core.seq.call(null,seq__14748_14752);if(temp__4092__auto___14761)
{var seq__14748_14762__$1 = temp__4092__auto___14761;if(cljs.core.chunked_seq_QMARK_.call(null,seq__14748_14762__$1))
{var c__4263__auto___14763 = cljs.core.chunk_first.call(null,seq__14748_14762__$1);{
var G__14764 = cljs.core.chunk_rest.call(null,seq__14748_14762__$1);
var G__14765 = c__4263__auto___14763;
var G__14766 = cljs.core.count.call(null,c__4263__auto___14763);
var G__14767 = 0;
seq__14748_14752 = G__14764;
chunk__14749_14753 = G__14765;
count__14750_14754 = G__14766;
i__14751_14755 = G__14767;
continue;
}
} else
{var exclude_14768 = cljs.core.first.call(null,seq__14748_14762__$1);(new cljs.core.Keyword(null,"seen","seen",1017430509).cljs$core$IFn$_invoke$arity$1(res)[exclude_14768] = true);
{
var G__14769 = cljs.core.next.call(null,seq__14748_14762__$1);
var G__14770 = null;
var G__14771 = 0;
var G__14772 = 0;
seq__14748_14752 = G__14769;
chunk__14749_14753 = G__14770;
count__14750_14754 = G__14771;
i__14751_14755 = G__14772;
continue;
}
}
} else
{}
}
break;
}
} else
{}
(new cljs.core.Keyword(null,"seen","seen",1017430509).cljs$core$IFn$_invoke$arity$1(res)[lt.object.__GT_behavior_name.call(null,cur)] = true);
} else
{}
cljs.core.conj_BANG_.call(null,new cljs.core.Keyword(null,"final","final",1111340264).cljs$core$IFn$_invoke$arity$1(res),cur);
return res;
}
});})(duped))
,new cljs.core.PersistentArrayMap(null, 2, [new cljs.core.Keyword(null,"seen","seen",1017430509),lt.object.ts__GT_negations.call(null,ts),new cljs.core.Keyword(null,"final","final",1111340264),cljs.core.transient$.call(null,cljs.core.PersistentVector.EMPTY)], null),duped);return cljs.core.reverse.call(null,cljs.core.persistent_BANG_.call(null,new cljs.core.Keyword(null,"final","final",1111340264).cljs$core$IFn$_invoke$arity$1(de_duped)));
});
lt.object.trigger__GT_behaviors = (function trigger__GT_behaviors(trig,ts){return cljs.core.get.call(null,lt.object.__GT_triggers.call(null,lt.object.tags__GT_behaviors.call(null,ts)),trig);
});
lt.object.safe_report_error = (function safe_report_error(e){if(cljs.core.truth_(lt.objs.console))
{return lt.objs.console.error(e);
} else
{return console.error(((typeof e === 'string')?e:e.stack));
}
});
lt.object.raise_STAR_ = (function() {
var raise_STAR_ = null;
var raise_STAR___3 = (function (obj,reactions,args){return raise_STAR_.call(null,obj,reactions,args,null);
});
var raise_STAR___4 = (function (obj,reactions,args,trigger){var seq__14787 = cljs.core.seq.call(null,reactions);var chunk__14790 = null;var count__14791 = 0;var i__14792 = 0;while(true){
if((i__14792 < count__14791))
{var r = cljs.core._nth.call(null,chunk__14790,i__14792);var func = new cljs.core.Keyword(null,"reaction","reaction",4441361819).cljs$core$IFn$_invoke$arity$1(lt.object.__GT_behavior.call(null,r));var args__$1 = ((cljs.core.coll_QMARK_.call(null,r))?cljs.core.concat.call(null,cljs.core.rest.call(null,r),args):args);var meta = ((cljs.core.coll_QMARK_.call(null,r))?cljs.core.meta.call(null,r):cljs.core.PersistentArrayMap.EMPTY);if(cljs.core.truth_(func))
{try{var start14796_14801 = (new Date()).getTime();var _STAR_behavior_meta_STAR_14797_14802 = lt.object._STAR_behavior_meta_STAR_;try{lt.object._STAR_behavior_meta_STAR_ = meta;
cljs.core.apply.call(null,func,obj,args__$1);
}finally {lt.object._STAR_behavior_meta_STAR_ = _STAR_behavior_meta_STAR_14797_14802;
}if(cljs.core._EQ_.call(null,trigger,new cljs.core.Keyword(null,"object.behavior.time","object.behavior.time",854340588)))
{} else
{lt.object.raise.call(null,obj,new cljs.core.Keyword(null,"object.behavior.time","object.behavior.time",854340588),r,((new Date()).getTime() - start14796_14801),trigger);
}
}catch (e14795){var e_14803 = e14795;lt.object.safe_report_error.call(null,[cljs.core.str("Invalid behavior: "),cljs.core.str(new cljs.core.Keyword(null,"name","name",1017277949).cljs$core$IFn$_invoke$arity$1(lt.object.__GT_behavior.call(null,r)))].join(''));
lt.object.safe_report_error.call(null,e_14803);
}{
var G__14804 = seq__14787;
var G__14805 = chunk__14790;
var G__14806 = count__14791;
var G__14807 = (i__14792 + 1);
seq__14787 = G__14804;
chunk__14790 = G__14805;
count__14791 = G__14806;
i__14792 = G__14807;
continue;
}
} else
{{
var G__14808 = seq__14787;
var G__14809 = chunk__14790;
var G__14810 = count__14791;
var G__14811 = (i__14792 + 1);
seq__14787 = G__14808;
chunk__14790 = G__14809;
count__14791 = G__14810;
i__14792 = G__14811;
continue;
}
}
} else
{var temp__4092__auto__ = cljs.core.seq.call(null,seq__14787);if(temp__4092__auto__)
{var seq__14787__$1 = temp__4092__auto__;if(cljs.core.chunked_seq_QMARK_.call(null,seq__14787__$1))
{var c__4263__auto__ = cljs.core.chunk_first.call(null,seq__14787__$1);{
var G__14812 = cljs.core.chunk_rest.call(null,seq__14787__$1);
var G__14813 = c__4263__auto__;
var G__14814 = cljs.core.count.call(null,c__4263__auto__);
var G__14815 = 0;
seq__14787 = G__14812;
chunk__14790 = G__14813;
count__14791 = G__14814;
i__14792 = G__14815;
continue;
}
} else
{var r = cljs.core.first.call(null,seq__14787__$1);var func = new cljs.core.Keyword(null,"reaction","reaction",4441361819).cljs$core$IFn$_invoke$arity$1(lt.object.__GT_behavior.call(null,r));var args__$1 = ((cljs.core.coll_QMARK_.call(null,r))?cljs.core.concat.call(null,cljs.core.rest.call(null,r),args):args);var meta = ((cljs.core.coll_QMARK_.call(null,r))?cljs.core.meta.call(null,r):cljs.core.PersistentArrayMap.EMPTY);if(cljs.core.truth_(func))
{try{var start14799_14816 = (new Date()).getTime();var _STAR_behavior_meta_STAR_14800_14817 = lt.object._STAR_behavior_meta_STAR_;try{lt.object._STAR_behavior_meta_STAR_ = meta;
cljs.core.apply.call(null,func,obj,args__$1);
}finally {lt.object._STAR_behavior_meta_STAR_ = _STAR_behavior_meta_STAR_14800_14817;
}if(cljs.core._EQ_.call(null,trigger,new cljs.core.Keyword(null,"object.behavior.time","object.behavior.time",854340588)))
{} else
{lt.object.raise.call(null,obj,new cljs.core.Keyword(null,"object.behavior.time","object.behavior.time",854340588),r,((new Date()).getTime() - start14799_14816),trigger);
}
}catch (e14798){var e_14818 = e14798;lt.object.safe_report_error.call(null,[cljs.core.str("Invalid behavior: "),cljs.core.str(new cljs.core.Keyword(null,"name","name",1017277949).cljs$core$IFn$_invoke$arity$1(lt.object.__GT_behavior.call(null,r)))].join(''));
lt.object.safe_report_error.call(null,e_14818);
}{
var G__14819 = cljs.core.next.call(null,seq__14787__$1);
var G__14820 = null;
var G__14821 = 0;
var G__14822 = 0;
seq__14787 = G__14819;
chunk__14790 = G__14820;
count__14791 = G__14821;
i__14792 = G__14822;
continue;
}
} else
{{
var G__14823 = cljs.core.next.call(null,seq__14787__$1);
var G__14824 = null;
var G__14825 = 0;
var G__14826 = 0;
seq__14787 = G__14823;
chunk__14790 = G__14824;
count__14791 = G__14825;
i__14792 = G__14826;
continue;
}
}
}
} else
{return null;
}
}
break;
}
});
raise_STAR_ = function(obj,reactions,args,trigger){
switch(arguments.length){
case 3:
return raise_STAR___3.call(this,obj,reactions,args);
case 4:
return raise_STAR___4.call(this,obj,reactions,args,trigger);
}
throw(new Error('Invalid arity: ' + arguments.length));
};
raise_STAR_.cljs$core$IFn$_invoke$arity$3 = raise_STAR___3;
raise_STAR_.cljs$core$IFn$_invoke$arity$4 = raise_STAR___4;
return raise_STAR_;
})()
;
/**
* Invoke object's behavior fns for given trigger. Args are passed to behavior fns
* @param {...*} var_args
*/
lt.object.raise = (function() { 
var raise__delegate = function (obj,k,args){var reactions = k.call(null,new cljs.core.Keyword(null,"listeners","listeners",4090152369).cljs$core$IFn$_invoke$arity$1(cljs.core.deref.call(null,obj)));return lt.object.raise_STAR_.call(null,obj,reactions,args,k);
};
var raise = function (obj,k,var_args){
var args = null;if (arguments.length > 2) {
  args = cljs.core.array_seq(Array.prototype.slice.call(arguments, 2),0);} 
return raise__delegate.call(this,obj,k,args);};
raise.cljs$lang$maxFixedArity = 2;
raise.cljs$lang$applyTo = (function (arglist__14827){
var obj = cljs.core.first(arglist__14827);
arglist__14827 = cljs.core.next(arglist__14827);
var k = cljs.core.first(arglist__14827);
var args = cljs.core.rest(arglist__14827);
return raise__delegate(obj,k,args);
});
raise.cljs$core$IFn$_invoke$arity$variadic = raise__delegate;
return raise;
})()
;
/**
* For a given behavior keyword id, call its :reaction fn with given args
* @param {...*} var_args
*/
lt.object.call_behavior_reaction = (function() { 
var call_behavior_reaction__delegate = function (id,args){var behavior_fn = new cljs.core.Keyword(null,"reaction","reaction",4441361819).cljs$core$IFn$_invoke$arity$1(lt.object.__GT_behavior.call(null,id));if(cljs.core.truth_(behavior_fn))
{} else
{throw (new Error([cljs.core.str("Assert failed: "),cljs.core.str(cljs.core.pr_str.call(null,new cljs.core.Symbol(null,"behavior-fn","behavior-fn",-1300659236,null)))].join('')));
}
return cljs.core.apply.call(null,behavior_fn,args);
};
var call_behavior_reaction = function (id,var_args){
var args = null;if (arguments.length > 1) {
  args = cljs.core.array_seq(Array.prototype.slice.call(arguments, 1),0);} 
return call_behavior_reaction__delegate.call(this,id,args);};
call_behavior_reaction.cljs$lang$maxFixedArity = 1;
call_behavior_reaction.cljs$lang$applyTo = (function (arglist__14828){
var id = cljs.core.first(arglist__14828);
var args = cljs.core.rest(arglist__14828);
return call_behavior_reaction__delegate(id,args);
});
call_behavior_reaction.cljs$core$IFn$_invoke$arity$variadic = call_behavior_reaction__delegate;
return call_behavior_reaction;
})()
;
lt.object.update_listeners = (function() {
var update_listeners = null;
var update_listeners__1 = (function (obj){return update_listeners.call(null,obj,null);
});
var update_listeners__2 = (function (obj,instants){var cur = cljs.core.deref.call(null,obj);var behs = cljs.core.set.call(null,cljs.core.concat.call(null,new cljs.core.Keyword(null,"behaviors","behaviors",607554515).cljs$core$IFn$_invoke$arity$1(cur),lt.object.tags__GT_behaviors.call(null,new cljs.core.Keyword(null,"tags","tags",1017456523).cljs$core$IFn$_invoke$arity$1(cur))));var trigs = lt.object.__GT_triggers.call(null,behs);var trigs__$1 = (cljs.core.truth_(new cljs.core.Keyword(null,"object.instant-load","object.instant-load",4025433875).cljs$core$IFn$_invoke$arity$1(trigs))?(function (){lt.object.raise_STAR_.call(null,obj,new cljs.core.Keyword(null,"object.instant-load","object.instant-load",4025433875).cljs$core$IFn$_invoke$arity$1(trigs),null,new cljs.core.Keyword(null,"object.instant-load","object.instant-load",4025433875));
return lt.object.__GT_triggers.call(null,behs);
})():trigs);var trigs__$2 = (cljs.core.truth_(instants)?trigs__$1:cljs.core.dissoc.call(null,trigs__$1,new cljs.core.Keyword(null,"object.instant","object.instant",773332388),new cljs.core.Keyword(null,"object.instant-load","object.instant-load",4025433875)));return cljs.core.assoc.call(null,cljs.core.deref.call(null,obj),new cljs.core.Keyword(null,"listeners","listeners",4090152369),trigs__$2);
});
update_listeners = function(obj,instants){
switch(arguments.length){
case 1:
return update_listeners__1.call(this,obj);
case 2:
return update_listeners__2.call(this,obj,instants);
}
throw(new Error('Invalid arity: ' + arguments.length));
};
update_listeners.cljs$core$IFn$_invoke$arity$1 = update_listeners__1;
update_listeners.cljs$core$IFn$_invoke$arity$2 = update_listeners__2;
return update_listeners;
})()
;
/**
* @param {...*} var_args
*/
lt.object.make_object_STAR_ = (function() { 
var make_object_STAR___delegate = function (name,r){var obj = cljs.core.merge.call(null,new cljs.core.PersistentArrayMap(null, 6, [new cljs.core.Keyword(null,"behaviors","behaviors",607554515),cljs.core.PersistentHashSet.EMPTY,new cljs.core.Keyword(null,"tags","tags",1017456523),cljs.core.PersistentHashSet.EMPTY,new cljs.core.Keyword(null,"triggers","triggers",2516997421),cljs.core.PersistentVector.EMPTY,new cljs.core.Keyword(null,"listeners","listeners",4090152369),cljs.core.PersistentArrayMap.EMPTY,new cljs.core.Keyword("lt.object","type","lt.object/type",701613666),name,new cljs.core.Keyword(null,"children","children",2673430897),cljs.core.PersistentArrayMap.EMPTY], null),cljs.core.apply.call(null,cljs.core.hash_map,r));return obj;
};
var make_object_STAR_ = function (name,var_args){
var r = null;if (arguments.length > 1) {
  r = cljs.core.array_seq(Array.prototype.slice.call(arguments, 1),0);} 
return make_object_STAR___delegate.call(this,name,r);};
make_object_STAR_.cljs$lang$maxFixedArity = 1;
make_object_STAR_.cljs$lang$applyTo = (function (arglist__14829){
var name = cljs.core.first(arglist__14829);
var r = cljs.core.rest(arglist__14829);
return make_object_STAR___delegate(name,r);
});
make_object_STAR_.cljs$core$IFn$_invoke$arity$variadic = make_object_STAR___delegate;
return make_object_STAR_;
})()
;
lt.object.store_object_STAR_ = (function store_object_STAR_(obj){lt.object.add.call(null,obj);
return obj;
});
/**
* Return all objects for given type (template name)
*/
lt.object.instances_by_type = (function instances_by_type(type){return cljs.core.filter.call(null,(function (p1__14830_SHARP_){return cljs.core._EQ_.call(null,type,new cljs.core.Keyword("lt.object","type","lt.object/type",701613666).cljs$core$IFn$_invoke$arity$1(cljs.core.deref.call(null,p1__14830_SHARP_)));
}),cljs.core.vals.call(null,cljs.core.deref.call(null,lt.object.instances)));
});
/**
* Merge map into object
*/
lt.object.merge_BANG_ = (function merge_BANG_(obj,m){if(cljs.core.truth_((function (){var and__3509__auto__ = m;if(cljs.core.truth_(and__3509__auto__))
{return !(cljs.core.map_QMARK_.call(null,m));
} else
{return and__3509__auto__;
}
})()))
{throw (new Error([cljs.core.str("Merge requires a map: "),cljs.core.str(m)].join('')));
} else
{}
return cljs.core.swap_BANG_.call(null,obj,cljs.core.merge,m);
});
lt.object.handle_redef = (function handle_redef(odef){var id = new cljs.core.Keyword("lt.object","type","lt.object/type",701613666).cljs$core$IFn$_invoke$arity$1(odef);var seq__14837_14843 = cljs.core.seq.call(null,lt.object.instances_by_type.call(null,id));var chunk__14839_14844 = null;var count__14840_14845 = 0;var i__14841_14846 = 0;while(true){
if((i__14841_14846 < count__14840_14845))
{var o_14847 = cljs.core._nth.call(null,chunk__14839_14844,i__14841_14846);var o_14848__$1 = cljs.core.deref.call(null,o_14847);var args_14849 = new cljs.core.Keyword(null,"args","args",1016906831).cljs$core$IFn$_invoke$arity$1(o_14848__$1);var old_14850 = new cljs.core.Keyword(null,"content","content",1965434859).cljs$core$IFn$_invoke$arity$1(o_14848__$1);var behs_14851 = cljs.core.set.call(null,new cljs.core.Keyword(null,"behaviors","behaviors",607554515).cljs$core$IFn$_invoke$arity$1(o_14848__$1));var inst_14852 = cljs.core.deref.call(null,lt.object.instances).call(null,lt.object.__GT_id.call(null,o_14848__$1));var neue_14853 = (cljs.core.truth_(new cljs.core.Keyword(null,"init","init",1017141378).cljs$core$IFn$_invoke$arity$1(odef))?cljs.core.apply.call(null,new cljs.core.Keyword(null,"init","init",1017141378).cljs$core$IFn$_invoke$arity$1(odef),inst_14852,args_14849):null);var neue_14854__$1 = ((cljs.core.vector_QMARK_.call(null,neue_14853))?crate.core.html.call(null,neue_14853):neue_14853);lt.object.merge_BANG_.call(null,inst_14852,new cljs.core.PersistentArrayMap(null, 3, [new cljs.core.Keyword(null,"tags","tags",1017456523),clojure.set.union.call(null,new cljs.core.Keyword(null,"tags","tags",1017456523).cljs$core$IFn$_invoke$arity$1(o_14848__$1),new cljs.core.Keyword(null,"tags","tags",1017456523).cljs$core$IFn$_invoke$arity$1(odef)),new cljs.core.Keyword(null,"behaviors","behaviors",607554515),clojure.set.union.call(null,behs_14851,cljs.core.set.call(null,new cljs.core.Keyword(null,"behaviors","behaviors",607554515).cljs$core$IFn$_invoke$arity$1(odef))),new cljs.core.Keyword(null,"content","content",1965434859),neue_14854__$1], null));
lt.object.merge_BANG_.call(null,inst_14852,lt.object.update_listeners.call(null,inst_14852));
if(cljs.core.truth_((function (){var and__3509__auto__ = old_14850;if(cljs.core.truth_(and__3509__auto__))
{return neue_14854__$1;
} else
{return and__3509__auto__;
}
})()))
{lt.util.dom.replace_with.call(null,old_14850,neue_14854__$1);
} else
{}
lt.object.raise.call(null,inst_14852,new cljs.core.Keyword(null,"redef","redef",1122293860));
{
var G__14855 = seq__14837_14843;
var G__14856 = chunk__14839_14844;
var G__14857 = count__14840_14845;
var G__14858 = (i__14841_14846 + 1);
seq__14837_14843 = G__14855;
chunk__14839_14844 = G__14856;
count__14840_14845 = G__14857;
i__14841_14846 = G__14858;
continue;
}
} else
{var temp__4092__auto___14859 = cljs.core.seq.call(null,seq__14837_14843);if(temp__4092__auto___14859)
{var seq__14837_14860__$1 = temp__4092__auto___14859;if(cljs.core.chunked_seq_QMARK_.call(null,seq__14837_14860__$1))
{var c__4263__auto___14861 = cljs.core.chunk_first.call(null,seq__14837_14860__$1);{
var G__14862 = cljs.core.chunk_rest.call(null,seq__14837_14860__$1);
var G__14863 = c__4263__auto___14861;
var G__14864 = cljs.core.count.call(null,c__4263__auto___14861);
var G__14865 = 0;
seq__14837_14843 = G__14862;
chunk__14839_14844 = G__14863;
count__14840_14845 = G__14864;
i__14841_14846 = G__14865;
continue;
}
} else
{var o_14866 = cljs.core.first.call(null,seq__14837_14860__$1);var o_14867__$1 = cljs.core.deref.call(null,o_14866);var args_14868 = new cljs.core.Keyword(null,"args","args",1016906831).cljs$core$IFn$_invoke$arity$1(o_14867__$1);var old_14869 = new cljs.core.Keyword(null,"content","content",1965434859).cljs$core$IFn$_invoke$arity$1(o_14867__$1);var behs_14870 = cljs.core.set.call(null,new cljs.core.Keyword(null,"behaviors","behaviors",607554515).cljs$core$IFn$_invoke$arity$1(o_14867__$1));var inst_14871 = cljs.core.deref.call(null,lt.object.instances).call(null,lt.object.__GT_id.call(null,o_14867__$1));var neue_14872 = (cljs.core.truth_(new cljs.core.Keyword(null,"init","init",1017141378).cljs$core$IFn$_invoke$arity$1(odef))?cljs.core.apply.call(null,new cljs.core.Keyword(null,"init","init",1017141378).cljs$core$IFn$_invoke$arity$1(odef),inst_14871,args_14868):null);var neue_14873__$1 = ((cljs.core.vector_QMARK_.call(null,neue_14872))?crate.core.html.call(null,neue_14872):neue_14872);lt.object.merge_BANG_.call(null,inst_14871,new cljs.core.PersistentArrayMap(null, 3, [new cljs.core.Keyword(null,"tags","tags",1017456523),clojure.set.union.call(null,new cljs.core.Keyword(null,"tags","tags",1017456523).cljs$core$IFn$_invoke$arity$1(o_14867__$1),new cljs.core.Keyword(null,"tags","tags",1017456523).cljs$core$IFn$_invoke$arity$1(odef)),new cljs.core.Keyword(null,"behaviors","behaviors",607554515),clojure.set.union.call(null,behs_14870,cljs.core.set.call(null,new cljs.core.Keyword(null,"behaviors","behaviors",607554515).cljs$core$IFn$_invoke$arity$1(odef))),new cljs.core.Keyword(null,"content","content",1965434859),neue_14873__$1], null));
lt.object.merge_BANG_.call(null,inst_14871,lt.object.update_listeners.call(null,inst_14871));
if(cljs.core.truth_((function (){var and__3509__auto__ = old_14869;if(cljs.core.truth_(and__3509__auto__))
{return neue_14873__$1;
} else
{return and__3509__auto__;
}
})()))
{lt.util.dom.replace_with.call(null,old_14869,neue_14873__$1);
} else
{}
lt.object.raise.call(null,inst_14871,new cljs.core.Keyword(null,"redef","redef",1122293860));
{
var G__14874 = cljs.core.next.call(null,seq__14837_14860__$1);
var G__14875 = null;
var G__14876 = 0;
var G__14877 = 0;
seq__14837_14843 = G__14874;
chunk__14839_14844 = G__14875;
count__14840_14845 = G__14876;
i__14841_14846 = G__14877;
continue;
}
}
} else
{}
}
break;
}
return id;
});
/**
* Create object template (type) given keyword name and key-value pairs.
* These pairs serve as default attributes for an object. Following keys
* have special meaning:
* 
* * :behaviors - Set of object's behaviors
* * :tags - Set of object's tags
* * :triggers - Set of object's triggers
* * :init - Init fn called when object is created. Fn's return value
* is hiccup html content and saved to :content
* * :listeners (internal) - Map of triggers to vectors of behaviors
* * :doc - Equivalent to a traditional function docstring.
* @param {...*} var_args
*/
lt.object.object_STAR_ = (function() { 
var object_STAR___delegate = function (name,r){return lt.object.handle_redef.call(null,lt.object.store_object_STAR_.call(null,cljs.core.apply.call(null,lt.object.make_object_STAR_,name,r)));
};
var object_STAR_ = function (name,var_args){
var r = null;if (arguments.length > 1) {
  r = cljs.core.array_seq(Array.prototype.slice.call(arguments, 1),0);} 
return object_STAR___delegate.call(this,name,r);};
object_STAR_.cljs$lang$maxFixedArity = 1;
object_STAR_.cljs$lang$applyTo = (function (arglist__14878){
var name = cljs.core.first(arglist__14878);
var r = cljs.core.rest(arglist__14878);
return object_STAR___delegate(name,r);
});
object_STAR_.cljs$core$IFn$_invoke$arity$variadic = object_STAR___delegate;
return object_STAR_;
})()
;
/**
* @param {...*} var_args
*/
lt.object.make_behavior_STAR_ = (function() { 
var make_behavior_STAR___delegate = function (name,r){var be = cljs.core.merge.call(null,new cljs.core.PersistentArrayMap(null, 1, [new cljs.core.Keyword(null,"name","name",1017277949),name], null),cljs.core.apply.call(null,cljs.core.hash_map,r));return be;
};
var make_behavior_STAR_ = function (name,var_args){
var r = null;if (arguments.length > 1) {
  r = cljs.core.array_seq(Array.prototype.slice.call(arguments, 1),0);} 
return make_behavior_STAR___delegate.call(this,name,r);};
make_behavior_STAR_.cljs$lang$maxFixedArity = 1;
make_behavior_STAR_.cljs$lang$applyTo = (function (arglist__14879){
var name = cljs.core.first(arglist__14879);
var r = cljs.core.rest(arglist__14879);
return make_behavior_STAR___delegate(name,r);
});
make_behavior_STAR_.cljs$core$IFn$_invoke$arity$variadic = make_behavior_STAR___delegate;
return make_behavior_STAR_;
})()
;
lt.object.store_behavior_STAR_ = (function store_behavior_STAR_(beh){lt.object.add_behavior.call(null,beh);
return new cljs.core.Keyword(null,"name","name",1017277949).cljs$core$IFn$_invoke$arity$1(beh);
});
lt.object.wrap_throttle = (function wrap_throttle(beh){var temp__4090__auto__ = new cljs.core.Keyword(null,"throttle","throttle",2497347228).cljs$core$IFn$_invoke$arity$1(beh);if(cljs.core.truth_(temp__4090__auto__))
{var thr = temp__4090__auto__;return cljs.core.assoc.call(null,beh,new cljs.core.Keyword(null,"reaction","reaction",4441361819),lt.util.js.throttle.call(null,thr,new cljs.core.Keyword(null,"reaction","reaction",4441361819).cljs$core$IFn$_invoke$arity$1(beh)));
} else
{return beh;
}
});
lt.object.wrap_debounce = (function wrap_debounce(beh){var temp__4090__auto__ = new cljs.core.Keyword(null,"debounce","debounce",1556599227).cljs$core$IFn$_invoke$arity$1(beh);if(cljs.core.truth_(temp__4090__auto__))
{var thr = temp__4090__auto__;return cljs.core.assoc.call(null,beh,new cljs.core.Keyword(null,"reaction","reaction",4441361819),lt.util.js.debounce.call(null,thr,new cljs.core.Keyword(null,"reaction","reaction",4441361819).cljs$core$IFn$_invoke$arity$1(beh)));
} else
{return beh;
}
});
/**
* @param {...*} var_args
*/
lt.object.behavior_STAR_ = (function() { 
var behavior_STAR___delegate = function (name,r){return lt.object.store_behavior_STAR_.call(null,lt.object.wrap_debounce.call(null,lt.object.wrap_throttle.call(null,cljs.core.apply.call(null,lt.object.make_behavior_STAR_,name,r))));
};
var behavior_STAR_ = function (name,var_args){
var r = null;if (arguments.length > 1) {
  r = cljs.core.array_seq(Array.prototype.slice.call(arguments, 1),0);} 
return behavior_STAR___delegate.call(this,name,r);};
behavior_STAR_.cljs$lang$maxFixedArity = 1;
behavior_STAR_.cljs$lang$applyTo = (function (arglist__14880){
var name = cljs.core.first(arglist__14880);
var r = cljs.core.rest(arglist__14880);
return behavior_STAR___delegate(name,r);
});
behavior_STAR_.cljs$core$IFn$_invoke$arity$variadic = behavior_STAR___delegate;
return behavior_STAR_;
})()
;
/**
* Reduce over invoked object's behavior fns for given trigger. Start
* is initial value for reduce and any args are passed to behavior fn
* @param {...*} var_args
*/
lt.object.raise_reduce = (function() { 
var raise_reduce__delegate = function (obj,k,start,args){var reactions = k.call(null,new cljs.core.Keyword(null,"listeners","listeners",4090152369).cljs$core$IFn$_invoke$arity$1(cljs.core.deref.call(null,obj)));return cljs.core.reduce.call(null,(function (res,cur){var func = new cljs.core.Keyword(null,"reaction","reaction",4441361819).cljs$core$IFn$_invoke$arity$1(lt.object.__GT_behavior.call(null,cur));var args__$1 = ((cljs.core.coll_QMARK_.call(null,cur))?cljs.core.concat.call(null,cljs.core.rest.call(null,cur),args):args);var meta = ((cljs.core.coll_QMARK_.call(null,cur))?cljs.core.meta.call(null,cur):cljs.core.PersistentArrayMap.EMPTY);if(cljs.core.not.call(null,func))
{return res;
} else
{var _STAR_behavior_meta_STAR_14882 = lt.object._STAR_behavior_meta_STAR_;try{lt.object._STAR_behavior_meta_STAR_ = meta;
return cljs.core.apply.call(null,func,obj,res,args__$1);
}finally {lt.object._STAR_behavior_meta_STAR_ = _STAR_behavior_meta_STAR_14882;
}}
}),start,reactions);
};
var raise_reduce = function (obj,k,start,var_args){
var args = null;if (arguments.length > 3) {
  args = cljs.core.array_seq(Array.prototype.slice.call(arguments, 3),0);} 
return raise_reduce__delegate.call(this,obj,k,start,args);};
raise_reduce.cljs$lang$maxFixedArity = 3;
raise_reduce.cljs$lang$applyTo = (function (arglist__14883){
var obj = cljs.core.first(arglist__14883);
arglist__14883 = cljs.core.next(arglist__14883);
var k = cljs.core.first(arglist__14883);
arglist__14883 = cljs.core.next(arglist__14883);
var start = cljs.core.first(arglist__14883);
var args = cljs.core.rest(arglist__14883);
return raise_reduce__delegate(obj,k,start,args);
});
raise_reduce.cljs$core$IFn$_invoke$arity$variadic = raise_reduce__delegate;
return raise_reduce;
})()
;
/**
* Update object with update-in with [:key], fn and args
* @param {...*} var_args
*/
lt.object.update_BANG_ = (function() { 
var update_BANG___delegate = function (obj,r){return cljs.core.swap_BANG_.call(null,obj,(function (p1__14884_SHARP_){return cljs.core.apply.call(null,cljs.core.update_in,p1__14884_SHARP_,r);
}));
};
var update_BANG_ = function (obj,var_args){
var r = null;if (arguments.length > 1) {
  r = cljs.core.array_seq(Array.prototype.slice.call(arguments, 1),0);} 
return update_BANG___delegate.call(this,obj,r);};
update_BANG_.cljs$lang$maxFixedArity = 1;
update_BANG_.cljs$lang$applyTo = (function (arglist__14885){
var obj = cljs.core.first(arglist__14885);
var r = cljs.core.rest(arglist__14885);
return update_BANG___delegate(obj,r);
});
update_BANG_.cljs$core$IFn$_invoke$arity$variadic = update_BANG___delegate;
return update_BANG_;
})()
;
/**
* Update object with assoc-in for given key and value
*/
lt.object.assoc_in_BANG_ = (function assoc_in_BANG_(obj,k,v){if(cljs.core.truth_((function (){var and__3509__auto__ = k;if(cljs.core.truth_(and__3509__auto__))
{return !(cljs.core.sequential_QMARK_.call(null,k));
} else
{return and__3509__auto__;
}
})()))
{throw (new Error([cljs.core.str("Associate requires a sequence of keys: "),cljs.core.str(k)].join('')));
} else
{}
return cljs.core.swap_BANG_.call(null,obj,(function (p1__14886_SHARP_){return cljs.core.assoc_in.call(null,p1__14886_SHARP_,k,v);
}));
});
lt.object.__GT_inst = (function __GT_inst(o){if(cljs.core.map_QMARK_.call(null,o))
{return cljs.core.deref.call(null,lt.object.instances).call(null,lt.object.__GT_id.call(null,o));
} else
{if(crate.binding.deref_QMARK_.call(null,o))
{return o;
} else
{if(new cljs.core.Keyword(null,"else","else",1017020587))
{return cljs.core.deref.call(null,lt.object.instances).call(null,o);
} else
{return null;
}
}
}
});
/**
* Return DOM content associated with object
*/
lt.object.__GT_content = (function __GT_content(obj){return new cljs.core.Keyword(null,"content","content",1965434859).cljs$core$IFn$_invoke$arity$1(cljs.core.deref.call(null,obj));
});
/**
* Destroy object by calling its :destroy trigger, removing it from
* cache and removing associated DOM content
*/
lt.object.destroy_BANG_ = (function destroy_BANG_(obj){var temp__4092__auto__ = lt.object.__GT_inst.call(null,obj);if(cljs.core.truth_(temp__4092__auto__))
{var inst = temp__4092__auto__;lt.object.raise.call(null,inst,new cljs.core.Keyword(null,"destroy","destroy",2571277164));
cljs.core.swap_BANG_.call(null,lt.object.instances,cljs.core.dissoc,lt.object.__GT_id.call(null,inst));
if(cljs.core.truth_(lt.object.__GT_content.call(null,obj)))
{lt.util.dom.remove.call(null,lt.object.__GT_content.call(null,obj));
} else
{}
return cljs.core.reset_BANG_.call(null,obj,null);
} else
{return null;
}
});
lt.object.store_inst = (function store_inst(inst){cljs.core.swap_BANG_.call(null,lt.object.instances,cljs.core.assoc,new cljs.core.Keyword("lt.object","id","lt.object/id",706431105).cljs$core$IFn$_invoke$arity$1(cljs.core.deref.call(null,inst)),inst);
return inst;
});
/**
* Create object given keyword name of object template or an object template
* and key-value pairs. See object* for special keys.
* During object creation the following happens to object in order:
* 
* * :init fn is called with given args
* * :object.instant trigger is raised
* * :init trigger is raised
* @param {...*} var_args
*/
lt.object.create = (function() { 
var create__delegate = function (obj_name,args){var obj = (((obj_name instanceof cljs.core.Keyword))?cljs.core.deref.call(null,lt.object.object_defs).call(null,obj_name):obj_name);var id = (function (){var or__3521__auto__ = new cljs.core.Keyword("lt.object","id","lt.object/id",706431105).cljs$core$IFn$_invoke$arity$1(obj);if(cljs.core.truth_(or__3521__auto__))
{return or__3521__auto__;
} else
{return cljs.core.swap_BANG_.call(null,lt.object.obj_id,cljs.core.inc);
}
})();var inst = cljs.core.atom.call(null,cljs.core.assoc.call(null,cljs.core.dissoc.call(null,obj,new cljs.core.Keyword(null,"init","init",1017141378)),new cljs.core.Keyword("lt.object","id","lt.object/id",706431105),id,new cljs.core.Keyword(null,"args","args",1016906831),args,new cljs.core.Keyword(null,"behaviors","behaviors",607554515),cljs.core.set.call(null,new cljs.core.Keyword(null,"behaviors","behaviors",607554515).cljs$core$IFn$_invoke$arity$1(obj)),new cljs.core.Keyword(null,"tags","tags",1017456523),cljs.core.set.call(null,cljs.core.conj.call(null,new cljs.core.Keyword(null,"tags","tags",1017456523).cljs$core$IFn$_invoke$arity$1(obj),new cljs.core.Keyword(null,"object","object",4285503153)))));var inst__$1 = lt.object.store_inst.call(null,inst);var _ = lt.object.merge_BANG_.call(null,inst__$1,lt.object.update_listeners.call(null,inst__$1));var content = (cljs.core.truth_(new cljs.core.Keyword(null,"init","init",1017141378).cljs$core$IFn$_invoke$arity$1(obj))?cljs.core.apply.call(null,new cljs.core.Keyword(null,"init","init",1017141378).cljs$core$IFn$_invoke$arity$1(obj),inst__$1,args):null);var content__$1 = ((cljs.core.vector_QMARK_.call(null,content))?crate.core.html.call(null,content):content);var final$ = lt.object.merge_BANG_.call(null,inst__$1,new cljs.core.PersistentArrayMap(null, 1, [new cljs.core.Keyword(null,"content","content",1965434859),content__$1], null));cljs.core.add_watch.call(null,inst__$1,new cljs.core.Keyword("lt.object","change","lt.object/change",2456955616),(function (___$1,___$2,___$3,___$4){return lt.object.raise.call(null,inst__$1,new cljs.core.Keyword(null,"object.change","object.change",966833329));
}));
lt.object.raise_STAR_.call(null,inst__$1,lt.object.trigger__GT_behaviors.call(null,new cljs.core.Keyword(null,"object.instant","object.instant",773332388),new cljs.core.Keyword(null,"tags","tags",1017456523).cljs$core$IFn$_invoke$arity$1(cljs.core.deref.call(null,inst__$1))),null);
lt.object.raise.call(null,inst__$1,new cljs.core.Keyword(null,"init","init",1017141378));
return inst__$1;
};
var create = function (obj_name,var_args){
var args = null;if (arguments.length > 1) {
  args = cljs.core.array_seq(Array.prototype.slice.call(arguments, 1),0);} 
return create__delegate.call(this,obj_name,args);};
create.cljs$lang$maxFixedArity = 1;
create.cljs$lang$applyTo = (function (arglist__14887){
var obj_name = cljs.core.first(arglist__14887);
var args = cljs.core.rest(arglist__14887);
return create__delegate(obj_name,args);
});
create.cljs$core$IFn$_invoke$arity$variadic = create__delegate;
return create;
})()
;
lt.object.refresh_BANG_ = (function refresh_BANG_(obj){cljs.core.reset_BANG_.call(null,obj,lt.object.update_listeners.call(null,obj));
lt.object.raise_STAR_.call(null,obj,lt.object.trigger__GT_behaviors.call(null,new cljs.core.Keyword(null,"object.instant","object.instant",773332388),new cljs.core.Keyword(null,"tags","tags",1017456523).cljs$core$IFn$_invoke$arity$1(cljs.core.deref.call(null,obj))),null);
return lt.object.raise.call(null,obj,new cljs.core.Keyword(null,"object.refresh","object.refresh",4196174494));
});
/**
* Add behavior to object and update its listeners
*/
lt.object.add_behavior_BANG_ = (function add_behavior_BANG_(obj,behavior){lt.object.update_BANG_.call(null,obj,new cljs.core.PersistentVector(null, 1, 5, cljs.core.PersistentVector.EMPTY_NODE, [new cljs.core.Keyword(null,"behaviors","behaviors",607554515)], null),cljs.core.conj,behavior);
return cljs.core.reset_BANG_.call(null,obj,lt.object.update_listeners.call(null,obj));
});
/**
* Remove behavior from object and update its listeners
*/
lt.object.rem_behavior_BANG_ = (function rem_behavior_BANG_(obj,behavior){lt.object.update_BANG_.call(null,obj,new cljs.core.PersistentVector(null, 1, 5, cljs.core.PersistentVector.EMPTY_NODE, [new cljs.core.Keyword(null,"behaviors","behaviors",607554515)], null),(function (p1__14888_SHARP_){return cljs.core.remove.call(null,cljs.core.PersistentHashSet.fromArray([behavior], true),p1__14888_SHARP_);
}));
return cljs.core.reset_BANG_.call(null,obj,lt.object.update_listeners.call(null,obj));
});
lt.object.__GT_def = (function __GT_def(def_BAR_name){if(cljs.core.map_QMARK_.call(null,def_BAR_name))
{return def_BAR_name;
} else
{return cljs.core.deref.call(null,lt.object.object_defs).call(null,def_BAR_name);
}
});
/**
* Find object by its unique numerical id
*/
lt.object.by_id = (function by_id(id){if(cljs.core.truth_(id))
{return cljs.core.deref.call(null,lt.object.instances).call(null,id);
} else
{return null;
}
});
/**
* Find objects that have given tag
*/
lt.object.by_tag = (function by_tag(tag){return cljs.core.sort_by.call(null,cljs.core.comp.call(null,new cljs.core.Keyword("lt.object","id","lt.object/id",706431105),cljs.core.deref),cljs.core.filter.call(null,(function (p1__14889_SHARP_){var temp__4092__auto__ = new cljs.core.Keyword(null,"tags","tags",1017456523).cljs$core$IFn$_invoke$arity$1(cljs.core.deref.call(null,p1__14889_SHARP_));if(cljs.core.truth_(temp__4092__auto__))
{var ts = temp__4092__auto__;return ts.call(null,tag);
} else
{return null;
}
}),cljs.core.vals.call(null,cljs.core.deref.call(null,lt.object.instances))));
});
lt.object.in_tag_QMARK_ = (function in_tag_QMARK_(tag,behavior){return cljs.core.first.call(null,cljs.core.filter.call(null,cljs.core.PersistentHashSet.fromArray([behavior], true),cljs.core.deref.call(null,lt.object.tags).call(null,tag)));
});
/**
* Return truthy if object has tag
*/
lt.object.has_tag_QMARK_ = (function has_tag_QMARK_(obj,tag){return new cljs.core.Keyword(null,"tags","tags",1017456523).cljs$core$IFn$_invoke$arity$1(cljs.core.deref.call(null,obj)).call(null,tag);
});
/**
* Add tags to given object and updates effected behaviors and listeners.
* ::tags-added trigger is raised on object after update
*/
lt.object.add_tags = (function add_tags(obj,ts){lt.object.update_BANG_.call(null,obj,new cljs.core.PersistentVector(null, 1, 5, cljs.core.PersistentVector.EMPTY_NODE, [new cljs.core.Keyword(null,"tags","tags",1017456523)], null),(function (p1__14890_SHARP_){return cljs.core.reduce.call(null,cljs.core.conj,p1__14890_SHARP_,cljs.core.filter.call(null,cljs.core.identity,ts));
}));
cljs.core.reset_BANG_.call(null,obj,lt.object.update_listeners.call(null,obj));
lt.object.raise.call(null,obj,new cljs.core.Keyword("lt.object","tags-added","lt.object/tags-added",1756253556),ts);
lt.object.raise_STAR_.call(null,obj,lt.object.trigger__GT_behaviors.call(null,new cljs.core.Keyword(null,"object.instant","object.instant",773332388),ts),null);
return obj;
});
/**
* Remove tags from given object and updates effected behaviors and listeners.
* ::tags-removed trigger is raised on object after update
*/
lt.object.remove_tags = (function remove_tags(obj,ts){var cur = cljs.core.deref.call(null,obj);var behs = cljs.core.apply.call(null,cljs.core.concat,cljs.core.map.call(null,cljs.core.deref.call(null,lt.object.tags),ts));var cur__$1 = cljs.core.update_in.call(null,cljs.core.update_in.call(null,cljs.core.update_in.call(null,cur,new cljs.core.PersistentVector(null, 1, 5, cljs.core.PersistentVector.EMPTY_NODE, [new cljs.core.Keyword(null,"tags","tags",1017456523)], null),((function (cur,behs){
return (function (p1__14891_SHARP_){return cljs.core.reduce.call(null,cljs.core.disj,p1__14891_SHARP_,ts);
});})(cur,behs))
),new cljs.core.PersistentVector(null, 1, 5, cljs.core.PersistentVector.EMPTY_NODE, [new cljs.core.Keyword(null,"behaviors","behaviors",607554515)], null),((function (cur,behs){
return (function (p1__14892_SHARP_){return cljs.core.remove.call(null,cljs.core.PersistentHashSet.fromArray([behs], true),p1__14892_SHARP_);
});})(cur,behs))
),new cljs.core.PersistentVector(null, 1, 5, cljs.core.PersistentVector.EMPTY_NODE, [new cljs.core.Keyword(null,"listeners","listeners",4090152369)], null),((function (cur,behs){
return (function (p1__14893_SHARP_){return cljs.core.apply.call(null,cljs.core.dissoc,p1__14893_SHARP_,ts);
});})(cur,behs))
);lt.object.merge_BANG_.call(null,obj,cur__$1);
cljs.core.reset_BANG_.call(null,obj,lt.object.update_listeners.call(null,obj));
lt.object.raise.call(null,obj,new cljs.core.Keyword("lt.object","tags-removed","lt.object/tags-removed",4080090644),ts);
return obj;
});
/**
* Associate behaviors to given tag and refresh objects with given tag
*/
lt.object.tag_behaviors = (function tag_behaviors(tag,behs){cljs.core.swap_BANG_.call(null,lt.object.tags,cljs.core.update_in,new cljs.core.PersistentVector(null, 1, 5, cljs.core.PersistentVector.EMPTY_NODE, [tag], null),(function (p1__14894_SHARP_){return cljs.core.reduce.call(null,cljs.core.conj,(function (){var or__3521__auto__ = p1__14894_SHARP_;if(cljs.core.truth_(or__3521__auto__))
{return or__3521__auto__;
} else
{return cljs.core.List.EMPTY;
}
})(),behs);
}));
var seq__14899_14903 = cljs.core.seq.call(null,lt.object.by_tag.call(null,tag));var chunk__14900_14904 = null;var count__14901_14905 = 0;var i__14902_14906 = 0;while(true){
if((i__14902_14906 < count__14901_14905))
{var cur_14907 = cljs.core._nth.call(null,chunk__14900_14904,i__14902_14906);lt.object.refresh_BANG_.call(null,cur_14907);
{
var G__14908 = seq__14899_14903;
var G__14909 = chunk__14900_14904;
var G__14910 = count__14901_14905;
var G__14911 = (i__14902_14906 + 1);
seq__14899_14903 = G__14908;
chunk__14900_14904 = G__14909;
count__14901_14905 = G__14910;
i__14902_14906 = G__14911;
continue;
}
} else
{var temp__4092__auto___14912 = cljs.core.seq.call(null,seq__14899_14903);if(temp__4092__auto___14912)
{var seq__14899_14913__$1 = temp__4092__auto___14912;if(cljs.core.chunked_seq_QMARK_.call(null,seq__14899_14913__$1))
{var c__4263__auto___14914 = cljs.core.chunk_first.call(null,seq__14899_14913__$1);{
var G__14915 = cljs.core.chunk_rest.call(null,seq__14899_14913__$1);
var G__14916 = c__4263__auto___14914;
var G__14917 = cljs.core.count.call(null,c__4263__auto___14914);
var G__14918 = 0;
seq__14899_14903 = G__14915;
chunk__14900_14904 = G__14916;
count__14901_14905 = G__14917;
i__14902_14906 = G__14918;
continue;
}
} else
{var cur_14919 = cljs.core.first.call(null,seq__14899_14913__$1);lt.object.refresh_BANG_.call(null,cur_14919);
{
var G__14920 = cljs.core.next.call(null,seq__14899_14913__$1);
var G__14921 = null;
var G__14922 = 0;
var G__14923 = 0;
seq__14899_14903 = G__14920;
chunk__14900_14904 = G__14921;
count__14901_14905 = G__14922;
i__14902_14906 = G__14923;
continue;
}
}
} else
{}
}
break;
}
return cljs.core.deref.call(null,lt.object.tags).call(null,tag);
});
lt.object.remove_tag_behaviors = (function remove_tag_behaviors(tag,behs){cljs.core.swap_BANG_.call(null,lt.object.tags,cljs.core.update_in,new cljs.core.PersistentVector(null, 1, 5, cljs.core.PersistentVector.EMPTY_NODE, [tag], null),(function (p1__14924_SHARP_){return cljs.core.remove.call(null,cljs.core.set.call(null,behs),(function (){var or__3521__auto__ = p1__14924_SHARP_;if(cljs.core.truth_(or__3521__auto__))
{return or__3521__auto__;
} else
{return cljs.core.List.EMPTY;
}
})());
}));
var seq__14937 = cljs.core.seq.call(null,lt.object.by_tag.call(null,tag));var chunk__14942 = null;var count__14943 = 0;var i__14944 = 0;while(true){
if((i__14944 < count__14943))
{var cur = cljs.core._nth.call(null,chunk__14942,i__14944);var seq__14945_14949 = cljs.core.seq.call(null,behs);var chunk__14946_14950 = null;var count__14947_14951 = 0;var i__14948_14952 = 0;while(true){
if((i__14948_14952 < count__14947_14951))
{var b_14953 = cljs.core._nth.call(null,chunk__14946_14950,i__14948_14952);lt.object.rem_behavior_BANG_.call(null,cur,b_14953);
{
var G__14954 = seq__14945_14949;
var G__14955 = chunk__14946_14950;
var G__14956 = count__14947_14951;
var G__14957 = (i__14948_14952 + 1);
seq__14945_14949 = G__14954;
chunk__14946_14950 = G__14955;
count__14947_14951 = G__14956;
i__14948_14952 = G__14957;
continue;
}
} else
{var temp__4092__auto___14958 = cljs.core.seq.call(null,seq__14945_14949);if(temp__4092__auto___14958)
{var seq__14945_14959__$1 = temp__4092__auto___14958;if(cljs.core.chunked_seq_QMARK_.call(null,seq__14945_14959__$1))
{var c__4263__auto___14960 = cljs.core.chunk_first.call(null,seq__14945_14959__$1);{
var G__14961 = cljs.core.chunk_rest.call(null,seq__14945_14959__$1);
var G__14962 = c__4263__auto___14960;
var G__14963 = cljs.core.count.call(null,c__4263__auto___14960);
var G__14964 = 0;
seq__14945_14949 = G__14961;
chunk__14946_14950 = G__14962;
count__14947_14951 = G__14963;
i__14948_14952 = G__14964;
continue;
}
} else
{var b_14965 = cljs.core.first.call(null,seq__14945_14959__$1);lt.object.rem_behavior_BANG_.call(null,cur,b_14965);
{
var G__14966 = cljs.core.next.call(null,seq__14945_14959__$1);
var G__14967 = null;
var G__14968 = 0;
var G__14969 = 0;
seq__14945_14949 = G__14966;
chunk__14946_14950 = G__14967;
count__14947_14951 = G__14968;
i__14948_14952 = G__14969;
continue;
}
}
} else
{}
}
break;
}
{
var G__14970 = seq__14937;
var G__14971 = chunk__14942;
var G__14972 = count__14943;
var G__14973 = (i__14944 + 1);
seq__14937 = G__14970;
chunk__14942 = G__14971;
count__14943 = G__14972;
i__14944 = G__14973;
continue;
}
} else
{var temp__4092__auto__ = cljs.core.seq.call(null,seq__14937);if(temp__4092__auto__)
{var seq__14937__$1 = temp__4092__auto__;if(cljs.core.chunked_seq_QMARK_.call(null,seq__14937__$1))
{var c__4263__auto__ = cljs.core.chunk_first.call(null,seq__14937__$1);{
var G__14974 = cljs.core.chunk_rest.call(null,seq__14937__$1);
var G__14975 = c__4263__auto__;
var G__14976 = cljs.core.count.call(null,c__4263__auto__);
var G__14977 = 0;
seq__14937 = G__14974;
chunk__14942 = G__14975;
count__14943 = G__14976;
i__14944 = G__14977;
continue;
}
} else
{var cur = cljs.core.first.call(null,seq__14937__$1);var seq__14938_14978 = cljs.core.seq.call(null,behs);var chunk__14939_14979 = null;var count__14940_14980 = 0;var i__14941_14981 = 0;while(true){
if((i__14941_14981 < count__14940_14980))
{var b_14982 = cljs.core._nth.call(null,chunk__14939_14979,i__14941_14981);lt.object.rem_behavior_BANG_.call(null,cur,b_14982);
{
var G__14983 = seq__14938_14978;
var G__14984 = chunk__14939_14979;
var G__14985 = count__14940_14980;
var G__14986 = (i__14941_14981 + 1);
seq__14938_14978 = G__14983;
chunk__14939_14979 = G__14984;
count__14940_14980 = G__14985;
i__14941_14981 = G__14986;
continue;
}
} else
{var temp__4092__auto___14987__$1 = cljs.core.seq.call(null,seq__14938_14978);if(temp__4092__auto___14987__$1)
{var seq__14938_14988__$1 = temp__4092__auto___14987__$1;if(cljs.core.chunked_seq_QMARK_.call(null,seq__14938_14988__$1))
{var c__4263__auto___14989 = cljs.core.chunk_first.call(null,seq__14938_14988__$1);{
var G__14990 = cljs.core.chunk_rest.call(null,seq__14938_14988__$1);
var G__14991 = c__4263__auto___14989;
var G__14992 = cljs.core.count.call(null,c__4263__auto___14989);
var G__14993 = 0;
seq__14938_14978 = G__14990;
chunk__14939_14979 = G__14991;
count__14940_14980 = G__14992;
i__14941_14981 = G__14993;
continue;
}
} else
{var b_14994 = cljs.core.first.call(null,seq__14938_14988__$1);lt.object.rem_behavior_BANG_.call(null,cur,b_14994);
{
var G__14995 = cljs.core.next.call(null,seq__14938_14988__$1);
var G__14996 = null;
var G__14997 = 0;
var G__14998 = 0;
seq__14938_14978 = G__14995;
chunk__14939_14979 = G__14996;
count__14940_14980 = G__14997;
i__14941_14981 = G__14998;
continue;
}
}
} else
{}
}
break;
}
{
var G__14999 = cljs.core.next.call(null,seq__14937__$1);
var G__15000 = null;
var G__15001 = 0;
var G__15002 = 0;
seq__14937 = G__14999;
chunk__14942 = G__15000;
count__14943 = G__15001;
i__14944 = G__15002;
continue;
}
}
} else
{return null;
}
}
break;
}
});
/**
* 
*/
lt.object.__BEH__add_tag = (function __BEH__add_tag(this$,t){if(cljs.core.truth_(t))
{return lt.object.add_tags.call(null,this$,((cljs.core.coll_QMARK_.call(null,t))?t:new cljs.core.PersistentVector(null, 1, 5, cljs.core.PersistentVector.EMPTY_NODE, [t], null)));
} else
{return null;
}
});
lt.object.behavior_STAR_.call(null,new cljs.core.Keyword("lt.object","add-tag","lt.object/add-tag",1703923742),new cljs.core.Keyword(null,"reaction","reaction",4441361819),lt.object.__BEH__add_tag,new cljs.core.Keyword(null,"desc","desc",1016984067),"App: Add tag to object",new cljs.core.Keyword(null,"params","params",4313443576),new cljs.core.PersistentVector(null, 1, 5, cljs.core.PersistentVector.EMPTY_NODE, [new cljs.core.PersistentArrayMap(null, 1, [new cljs.core.Keyword(null,"label","label",1116631654),"tag"], null)], null),new cljs.core.Keyword(null,"triggers","triggers",2516997421),new cljs.core.PersistentHashSet(null, new cljs.core.PersistentArrayMap(null, 1, [new cljs.core.Keyword(null,"object.instant","object.instant",773332388),null], null), null),new cljs.core.Keyword(null,"type","type",1017479852),new cljs.core.Keyword(null,"user","user",1017503549));
/**
* 
*/
lt.object.__BEH__remove_tag = (function __BEH__remove_tag(this$,t){if(cljs.core.truth_(lt.object.has_tag_QMARK_.call(null,this$,t)))
{return lt.object.remove_tags.call(null,this$,((cljs.core.coll_QMARK_.call(null,t))?t:new cljs.core.PersistentVector(null, 1, 5, cljs.core.PersistentVector.EMPTY_NODE, [t], null)));
} else
{return null;
}
});
lt.object.behavior_STAR_.call(null,new cljs.core.Keyword("lt.object","remove-tag","lt.object/remove-tag",3883925951),new cljs.core.Keyword(null,"reaction","reaction",4441361819),lt.object.__BEH__remove_tag,new cljs.core.Keyword(null,"desc","desc",1016984067),"App: Remove tag from object",new cljs.core.Keyword(null,"params","params",4313443576),new cljs.core.PersistentVector(null, 1, 5, cljs.core.PersistentVector.EMPTY_NODE, [new cljs.core.PersistentArrayMap(null, 1, [new cljs.core.Keyword(null,"label","label",1116631654),"tag"], null)], null),new cljs.core.Keyword(null,"triggers","triggers",2516997421),new cljs.core.PersistentHashSet(null, new cljs.core.PersistentArrayMap(null, 2, [new cljs.core.Keyword(null,"object.instant","object.instant",773332388),null,new cljs.core.Keyword("lt.object","tags-added","lt.object/tags-added",1756253556),null], null), null),new cljs.core.Keyword(null,"type","type",1017479852),new cljs.core.Keyword(null,"user","user",1017503549));
/**
* 
*/
lt.object.__BEH__shadow_tag = (function __BEH__shadow_tag(this$,to_shadow,to_add){var has_shadow_QMARK_ = lt.object.has_tag_QMARK_.call(null,this$,to_shadow);var has_add_QMARK_ = lt.object.has_tag_QMARK_.call(null,this$,to_add);if(cljs.core.truth_((function (){var and__3509__auto__ = has_shadow_QMARK_;if(cljs.core.truth_(and__3509__auto__))
{return cljs.core.not.call(null,has_add_QMARK_);
} else
{return and__3509__auto__;
}
})()))
{return lt.object.add_tags.call(null,this$,new cljs.core.PersistentVector(null, 1, 5, cljs.core.PersistentVector.EMPTY_NODE, [to_add], null));
} else
{if(cljs.core.truth_((function (){var and__3509__auto__ = cljs.core.not.call(null,has_shadow_QMARK_);if(and__3509__auto__)
{return has_add_QMARK_;
} else
{return and__3509__auto__;
}
})()))
{return lt.object.remove_tags.call(null,this$,new cljs.core.PersistentVector(null, 1, 5, cljs.core.PersistentVector.EMPTY_NODE, [to_add], null));
} else
{if(new cljs.core.Keyword(null,"else","else",1017020587))
{return null;
} else
{return null;
}
}
}
});
lt.object.behavior_STAR_.call(null,new cljs.core.Keyword("lt.object","shadow-tag","lt.object/shadow-tag",1731213395),new cljs.core.Keyword(null,"reaction","reaction",4441361819),lt.object.__BEH__shadow_tag,new cljs.core.Keyword(null,"desc","desc",1016984067),"App: Shadow a tag on an object",new cljs.core.Keyword(null,"params","params",4313443576),new cljs.core.PersistentVector(null, 2, 5, cljs.core.PersistentVector.EMPTY_NODE, [new cljs.core.PersistentArrayMap(null, 1, [new cljs.core.Keyword(null,"label","label",1116631654),"tag to shadow"], null),new cljs.core.PersistentArrayMap(null, 1, [new cljs.core.Keyword(null,"label","label",1116631654),"tag to add"], null)], null),new cljs.core.Keyword(null,"triggers","triggers",2516997421),new cljs.core.PersistentHashSet(null, new cljs.core.PersistentArrayMap(null, 3, [new cljs.core.Keyword(null,"object.instant","object.instant",773332388),null,new cljs.core.Keyword("lt.object","tags-added","lt.object/tags-added",1756253556),null,new cljs.core.Keyword("lt.object","tags-removed","lt.object/tags-removed",4080090644),null], null), null),new cljs.core.Keyword(null,"type","type",1017479852),new cljs.core.Keyword(null,"user","user",1017503549));
/**
* 
*/
lt.object.__BEH__report_time = (function __BEH__report_time(this$,beh,time,trigger){if(cljs.core.truth_(lt.objs.console))
{return lt.objs.console.log([cljs.core.str(beh),cljs.core.str(" triggered by "),cljs.core.str(trigger),cljs.core.str(" took "),cljs.core.str(time),cljs.core.str("ms")].join(''));
} else
{return null;
}
});
lt.object.behavior_STAR_.call(null,new cljs.core.Keyword("lt.object","report-time","lt.object/report-time",1387009782),new cljs.core.Keyword(null,"reaction","reaction",4441361819),lt.object.__BEH__report_time,new cljs.core.Keyword(null,"triggers","triggers",2516997421),new cljs.core.PersistentHashSet(null, new cljs.core.PersistentArrayMap(null, 1, [new cljs.core.Keyword(null,"object.behavior.time","object.behavior.time",854340588),null], null), null));
