// Compiled by ClojureScript 0.0-2138
goog.provide('lt.util.dom');
goog.require('cljs.core');
/**
* Return lazy seq of NodeList.
*/
lt.util.dom.lazy_nl_via_item = (function() {
var lazy_nl_via_item = null;
var lazy_nl_via_item__1 = (function (nl){return lazy_nl_via_item.call(null,nl,0);
});
var lazy_nl_via_item__2 = (function (nl,n){if((n < nl.length))
{return (new cljs.core.LazySeq(null,(function (){return cljs.core.cons.call(null,nl.item(n),lazy_nl_via_item.call(null,nl,(n + 1)));
}),null,null));
} else
{return null;
}
});
lazy_nl_via_item = function(nl,n){
switch(arguments.length){
case 1:
return lazy_nl_via_item__1.call(this,nl);
case 2:
return lazy_nl_via_item__2.call(this,nl,n);
}
throw(new Error('Invalid arity: ' + arguments.length));
};
lazy_nl_via_item.cljs$core$IFn$_invoke$arity$1 = lazy_nl_via_item__1;
lazy_nl_via_item.cljs$core$IFn$_invoke$arity$2 = lazy_nl_via_item__2;
return lazy_nl_via_item;
})()
;
HTMLCollection.prototype.cljs$core$IIndexed$ = true;
HTMLCollection.prototype.cljs$core$IIndexed$_nth$arity$2 = (function (this$,n){var this$__$1 = this;return this$__$1.item(n);
});
HTMLCollection.prototype.cljs$core$IIndexed$_nth$arity$3 = (function (this$,n,not_found){var this$__$1 = this;var or__3521__auto__ = this$__$1.item(n);if(cljs.core.truth_(or__3521__auto__))
{return or__3521__auto__;
} else
{return not_found;
}
});
HTMLCollection.prototype.cljs$core$ICounted$ = true;
HTMLCollection.prototype.cljs$core$ICounted$_count$arity$1 = (function (this$){var this$__$1 = this;return this$__$1.length;
});
HTMLCollection.prototype.cljs$core$ISeqable$ = true;
HTMLCollection.prototype.cljs$core$ISeqable$_seq$arity$1 = (function (this$){var this$__$1 = this;return lt.util.dom.lazy_nl_via_item.call(null,this$__$1);
});
NodeList.prototype.cljs$core$IIndexed$ = true;
NodeList.prototype.cljs$core$IIndexed$_nth$arity$2 = (function (this$,n){var this$__$1 = this;return this$__$1.item(n);
});
NodeList.prototype.cljs$core$IIndexed$_nth$arity$3 = (function (this$,n,not_found){var this$__$1 = this;var or__3521__auto__ = this$__$1.item(n);if(cljs.core.truth_(or__3521__auto__))
{return or__3521__auto__;
} else
{return not_found;
}
});
NodeList.prototype.cljs$core$ICounted$ = true;
NodeList.prototype.cljs$core$ICounted$_count$arity$1 = (function (this$){var this$__$1 = this;return this$__$1.length;
});
NodeList.prototype.cljs$core$ISeqable$ = true;
NodeList.prototype.cljs$core$ISeqable$_seq$arity$1 = (function (this$){var this$__$1 = this;return lt.util.dom.lazy_nl_via_item.call(null,this$__$1);
});
/**
* Create a text node containing string `text`.
*/
lt.util.dom.text_node = (function text_node(text){return document.createTextNode(text);
});
/**
* Returns a NodeList of all elements within `elem` that match `query`.
* 
* If `elem` is not specified then the entire document is used.
*/
lt.util.dom.$$ = (function() {
var $$ = null;
var $$__1 = (function (query){return $$.call(null,query,document);
});
var $$__2 = (function (query,elem){return elem.querySelectorAll(cljs.core.name.call(null,query));
});
$$ = function(query,elem){
switch(arguments.length){
case 1:
return $$__1.call(this,query);
case 2:
return $$__2.call(this,query,elem);
}
throw(new Error('Invalid arity: ' + arguments.length));
};
$$.cljs$core$IFn$_invoke$arity$1 = $$__1;
$$.cljs$core$IFn$_invoke$arity$2 = $$__2;
return $$;
})()
;
/**
* Returns the first element found within `elem` that matches `query`.
* 
* If `elem` is not specified then the entire document is used.
* 
* Example:
* ```
* ;; Assume there exists a div such as:
* ;; <div class="tabsets">
* 
* ($ "div .tabsets")
* ;;=> #<[object HTMLDivElement]>
* ```
*/
lt.util.dom.$ = (function() {
var $ = null;
var $__1 = (function (query){return $.call(null,query,document);
});
var $__2 = (function (query,elem){return elem.querySelector(cljs.core.name.call(null,query));
});
$ = function(query,elem){
switch(arguments.length){
case 1:
return $__1.call(this,query);
case 2:
return $__2.call(this,query,elem);
}
throw(new Error('Invalid arity: ' + arguments.length));
};
$.cljs$core$IFn$_invoke$arity$1 = $__1;
$.cljs$core$IFn$_invoke$arity$2 = $__2;
return $;
})()
;
/**
* Append `child` to the `parent` as a child node. If `child` already exists
* as a node then it is moved to the new location.
* 
* Returns `parent`.
*/
lt.util.dom.append = (function append(parent,child){parent.appendChild(child);
return parent;
});
/**
* Insert `child` as the first child node of `parent`, if there already exist children nodes.
* Otherwise, [[append]] `child`.
*/
lt.util.dom.prepend = (function prepend(parent,child){if(cljs.core.truth_(parent.firstChild))
{return parent.insertBefore(child,parent.firstChild);
} else
{return lt.util.dom.append.call(null,parent,child);
}
});
/**
* Add `class` to the classList of `elem`.
*/
lt.util.dom.add_class = (function add_class(elem,class$){if(cljs.core.truth_((function (){var and__3509__auto__ = elem;if(cljs.core.truth_(and__3509__auto__))
{return !(cljs.core.empty_QMARK_.call(null,cljs.core.name.call(null,class$)));
} else
{return and__3509__auto__;
}
})()))
{return elem.classList.add(cljs.core.name.call(null,class$));
} else
{return null;
}
});
/**
* Remove `class` from the classList of `elem`.
*/
lt.util.dom.remove_class = (function remove_class(elem,class$){if(cljs.core.truth_((function (){var and__3509__auto__ = elem;if(cljs.core.truth_(and__3509__auto__))
{return !(cljs.core.empty_QMARK_.call(null,cljs.core.name.call(null,class$)));
} else
{return and__3509__auto__;
}
})()))
{return elem.classList.remove(cljs.core.name.call(null,class$));
} else
{return null;
}
});
/**
* True when `elem` has `class` in its classList.
*/
lt.util.dom.has_class_QMARK_ = (function has_class_QMARK_(elem,class$){if(cljs.core.truth_((function (){var and__3509__auto__ = elem;if(cljs.core.truth_(and__3509__auto__))
{return !(cljs.core.empty_QMARK_.call(null,cljs.core.name.call(null,class$)));
} else
{return and__3509__auto__;
}
})()))
{return elem.classList.contains(cljs.core.name.call(null,class$));
} else
{return null;
}
});
/**
* If `elem` has `class` then remove `class`. Otherwise, `class` is added to `elem`.
*/
lt.util.dom.toggle_class = (function toggle_class(elem,class$){if(cljs.core.truth_(lt.util.dom.has_class_QMARK_.call(null,elem,class$)))
{return lt.util.dom.remove_class.call(null,elem,class$);
} else
{return lt.util.dom.add_class.call(null,elem,class$);
}
});
/**
* Add each key-value pair in `things` to `elem`'s style.
* 
* Returns `nil`, if change was successful.
* 
* Example:
* ```
* ;; Assume there exists a div such as:
* ;; <div class="tabsets" style="bottom: 34px;">
* 
* ;; Returns nil, but makes the change.
* (dom/set-css ($ "div") {"bottom" "50px"})
* ;;=> nil
* ;; div is now: <div class="tabsets" style="bottom: 50px;">
* ```
*/
lt.util.dom.set_css = (function set_css(elem,things){var seq__4909 = cljs.core.seq.call(null,things);var chunk__4910 = null;var count__4911 = 0;var i__4912 = 0;while(true){
if((i__4912 < count__4911))
{var vec__4913 = cljs.core._nth.call(null,chunk__4910,i__4912);var k = cljs.core.nth.call(null,vec__4913,0,null);var v = cljs.core.nth.call(null,vec__4913,1,null);(elem.style[cljs.core.name.call(null,k)] = (((v instanceof cljs.core.Keyword))?cljs.core.name.call(null,v):v));
{
var G__4915 = seq__4909;
var G__4916 = chunk__4910;
var G__4917 = count__4911;
var G__4918 = (i__4912 + 1);
seq__4909 = G__4915;
chunk__4910 = G__4916;
count__4911 = G__4917;
i__4912 = G__4918;
continue;
}
} else
{var temp__4092__auto__ = cljs.core.seq.call(null,seq__4909);if(temp__4092__auto__)
{var seq__4909__$1 = temp__4092__auto__;if(cljs.core.chunked_seq_QMARK_.call(null,seq__4909__$1))
{var c__4263__auto__ = cljs.core.chunk_first.call(null,seq__4909__$1);{
var G__4919 = cljs.core.chunk_rest.call(null,seq__4909__$1);
var G__4920 = c__4263__auto__;
var G__4921 = cljs.core.count.call(null,c__4263__auto__);
var G__4922 = 0;
seq__4909 = G__4919;
chunk__4910 = G__4920;
count__4911 = G__4921;
i__4912 = G__4922;
continue;
}
} else
{var vec__4914 = cljs.core.first.call(null,seq__4909__$1);var k = cljs.core.nth.call(null,vec__4914,0,null);var v = cljs.core.nth.call(null,vec__4914,1,null);(elem.style[cljs.core.name.call(null,k)] = (((v instanceof cljs.core.Keyword))?cljs.core.name.call(null,v):v));
{
var G__4923 = cljs.core.next.call(null,seq__4909__$1);
var G__4924 = null;
var G__4925 = 0;
var G__4926 = 0;
seq__4909 = G__4923;
chunk__4910 = G__4924;
count__4911 = G__4925;
i__4912 = G__4926;
continue;
}
}
} else
{return null;
}
}
break;
}
});
/**
* If `things` is a map, sets the CSS of `elem` via [[set-css]]. Otherwise,
* returns what is located at key `things` in `elem`.
* 
* Example:
* ```
* ;; Assume there exists a div such as:
* ;; <div class="tabsets" style="bottom: 34px;">
* 
* (css ($ "div .tabsets") :bottom)
* ;;=> "34px"
* 
* ;; Returns nil, but makes the change.
* (css ($ "div .tabsets") {"bottom" "50px"})
* ;;=> nil
* 
* (css ($ "div .tabsets") "bottom")
* ;;=> "50px"
* ```
*/
lt.util.dom.css = (function css(elem,things){var things__$1 = ((cljs.core._EQ_.call(null,Object,cljs.core.type.call(null,things)))?cljs.core.js__GT_clj.call(null,things):things);if(cljs.core.map_QMARK_.call(null,things__$1))
{return lt.util.dom.set_css.call(null,elem,things__$1);
} else
{return (elem.style[cljs.core.name.call(null,things__$1)]);
}
});
/**
* Add each key-value pair in `things` to `elem`'s attributes.
* 
* Returns `nil`, if change was successful.
* 
* Example:
* ```
* ;; Assume there exists a div such as:
* ;; <div class="tabsets">
* 
* ;; Returns nil, but makes the change.
* (dom/set-attr ($ "div .tabsets") {:draggable "true"})
* ;;=> nil
* ;; div is now: <div class="tabsets" draggable="true";>
* ```
*/
lt.util.dom.set_attr = (function set_attr(elem,things){var seq__4933 = cljs.core.seq.call(null,things);var chunk__4934 = null;var count__4935 = 0;var i__4936 = 0;while(true){
if((i__4936 < count__4935))
{var vec__4937 = cljs.core._nth.call(null,chunk__4934,i__4936);var k = cljs.core.nth.call(null,vec__4937,0,null);var v = cljs.core.nth.call(null,vec__4937,1,null);elem.setAttribute(cljs.core.name.call(null,k),(((v instanceof cljs.core.Keyword))?cljs.core.name.call(null,v):v));
{
var G__4939 = seq__4933;
var G__4940 = chunk__4934;
var G__4941 = count__4935;
var G__4942 = (i__4936 + 1);
seq__4933 = G__4939;
chunk__4934 = G__4940;
count__4935 = G__4941;
i__4936 = G__4942;
continue;
}
} else
{var temp__4092__auto__ = cljs.core.seq.call(null,seq__4933);if(temp__4092__auto__)
{var seq__4933__$1 = temp__4092__auto__;if(cljs.core.chunked_seq_QMARK_.call(null,seq__4933__$1))
{var c__4263__auto__ = cljs.core.chunk_first.call(null,seq__4933__$1);{
var G__4943 = cljs.core.chunk_rest.call(null,seq__4933__$1);
var G__4944 = c__4263__auto__;
var G__4945 = cljs.core.count.call(null,c__4263__auto__);
var G__4946 = 0;
seq__4933 = G__4943;
chunk__4934 = G__4944;
count__4935 = G__4945;
i__4936 = G__4946;
continue;
}
} else
{var vec__4938 = cljs.core.first.call(null,seq__4933__$1);var k = cljs.core.nth.call(null,vec__4938,0,null);var v = cljs.core.nth.call(null,vec__4938,1,null);elem.setAttribute(cljs.core.name.call(null,k),(((v instanceof cljs.core.Keyword))?cljs.core.name.call(null,v):v));
{
var G__4947 = cljs.core.next.call(null,seq__4933__$1);
var G__4948 = null;
var G__4949 = 0;
var G__4950 = 0;
seq__4933 = G__4947;
chunk__4934 = G__4948;
count__4935 = G__4949;
i__4936 = G__4950;
continue;
}
}
} else
{return null;
}
}
break;
}
});
/**
* If `things` is a map, sets the attributes of `elem` via [[set-attr]]. Otherwise, returns
* what is located at key `things` in `elem`.
* 
* Example:
* ```
* ;; Assume there exists a div such as:
* ;; <div class="tabsets" draggable="true";>
* 
* (attr ($ "div .tabsets") "draggable")
* ;;=> "true"
* 
* ;; Returns nil, but makes the change.
* (attr ($ "div .tabsets") {"draggable" "false"})
* ;;=> nil
* 
* (attr ($ "div .tabsets") "draggable")
* ;;=> "false"
* ```
*/
lt.util.dom.attr = (function attr(elem,things){if(cljs.core.map_QMARK_.call(null,things))
{return lt.util.dom.set_attr.call(null,elem,things);
} else
{return elem.getAttribute(cljs.core.name.call(null,things));
}
});
/**
* Return the parent node of `elem`.
* 
* Note: using `parent` on the document node will result in a type error.
* 
* Example:
* ```
* (parent ($ "body"))
* ;;=> #<[object HTMLHtmlElement]>
* 
* (.-nodeName (parent ($ "body")))
* ;;=> "HTML"
* ```
*/
lt.util.dom.parent = (function parent(elem){return elem.parentNode;
});
/**
* Return the child nodes of `elem`.
*/
lt.util.dom.children = (function children(elem){return elem.children;
});
/**
* Remove `elem` from the DOM tree.
*/
lt.util.dom.remove = (function remove(elem){var temp__4092__auto__ = lt.util.dom.parent.call(null,elem);if(cljs.core.truth_(temp__4092__auto__))
{var p = temp__4092__auto__;return p.removeChild(elem);
} else
{return null;
}
});
/**
* Sets the inner HTML of `elem` to an empty string.
*/
lt.util.dom.empty = (function empty(elem){return elem.innerHTML = "";
});
/**
* If `v` is provided then set the value of `elem` to `v`. Otherwise, return the
* current value of `elem`.
* @param {...*} var_args
*/
lt.util.dom.val = (function() { 
var val__delegate = function (elem,p__4951){var vec__4953 = p__4951;var v = cljs.core.nth.call(null,vec__4953,0,null);if(cljs.core.not.call(null,v))
{return elem.value;
} else
{return elem.value = v;
}
};
var val = function (elem,var_args){
var p__4951 = null;if (arguments.length > 1) {
  p__4951 = cljs.core.array_seq(Array.prototype.slice.call(arguments, 1),0);} 
return val__delegate.call(this,elem,p__4951);};
val.cljs$lang$maxFixedArity = 1;
val.cljs$lang$applyTo = (function (arglist__4954){
var elem = cljs.core.first(arglist__4954);
var p__4951 = cljs.core.rest(arglist__4954);
return val__delegate(elem,p__4951);
});
val.cljs$core$IFn$_invoke$arity$variadic = val__delegate;
return val;
})()
;
/**
* Cancel event `e`, if it is cancelable. Does not stop further propagation.
* 
* See [[stop-propagation]].
*/
lt.util.dom.prevent = (function prevent(e){return e.preventDefault();
});
/**
* Stop further propagation of event `e`.
* 
* See [[prevent]].
*/
lt.util.dom.stop_propagation = (function stop_propagation(e){return e.stopPropagation();
});
/**
* Return child nodes of `elem`'s parent.
*/
lt.util.dom.siblings = (function siblings(elem){return lt.util.dom.parent.call(null,elem).children;
});
/**
* Starting with `elem`'s immediate parent going up, returns first parent of
* `elem` that has a selector matching `sel` or `nil` if no match is found.
*/
lt.util.dom.parents = (function parents(elem,sel){var root = lt.util.dom.parent.call(null,lt.util.dom.$.call(null,new cljs.core.Keyword(null,"body","body",1016933652)));var p = lt.util.dom.parent.call(null,elem);while(true){
if(cljs.core.truth_((function (){var and__3509__auto__ = p;if(cljs.core.truth_(and__3509__auto__))
{return cljs.core.not_EQ_.call(null,p,root);
} else
{return and__3509__auto__;
}
})()))
{if(cljs.core.truth_(p.webkitMatchesSelector(cljs.core.name.call(null,sel))))
{return p;
} else
{{
var G__4955 = lt.util.dom.parent.call(null,p);
p = G__4955;
continue;
}
}
} else
{return null;
}
break;
}
});
/**
* Returns the next element at the same level of `elem` in the DOM tree.
* `nil` if there are no siblings.
*/
lt.util.dom.next = (function next(elem){return elem.nextElementSibling;
});
/**
* Insert element `neue` into `elem`'s parent in the position before `elem`.
* 
* See [[after]].
*/
lt.util.dom.before = (function before(elem,neue){return lt.util.dom.parent.call(null,elem).insertBefore(neue,elem);
});
/**
* Insert element `neue` into `elem`'s parent in the position after `elem`.
* 
* See [[before]].
*/
lt.util.dom.after = (function after(elem,neue){var temp__4090__auto__ = lt.util.dom.next.call(null,elem);if(cljs.core.truth_(temp__4090__auto__))
{var n = temp__4090__auto__;return lt.util.dom.before.call(null,n,neue);
} else
{return lt.util.dom.append.call(null,lt.util.dom.parent.call(null,elem),neue);
}
});
/**
* Replace `orig` with `neue`.
*/
lt.util.dom.replace_with = (function replace_with(orig,neue){var temp__4092__auto__ = lt.util.dom.parent.call(null,orig);if(cljs.core.truth_(temp__4092__auto__))
{var p = temp__4092__auto__;return p.replaceChild(neue,orig);
} else
{return null;
}
});
/**
* Returns the height of the visible area for `elem`, in pixels. The value
* contains the height with the padding, but it does not include the scrollBar,
* border, and the margin.
*/
lt.util.dom.height = (function height(elem){return elem.clientHeight;
});
/**
* Returns the width of the visible area for `elem`, in pixels. The value
* contains the width with the padding, but it does not include the scrollBar,
* border, and the margin.
*/
lt.util.dom.width = (function width(elem){return elem.clientWidth;
});
/**
* Returns, in pixels, whichever is greater, the width of the content within
* `elem` or the width of `elem` itself.
*/
lt.util.dom.scroll_width = (function scroll_width(elem){return elem.scrollWidth;
});
/**
* Return, in pixels, the offset of `elem` relative to the top of the
* parent.
*/
lt.util.dom.offset_top = (function offset_top(elem){return elem.offsetTop;
});
/**
* Returns or sets the scrollTop value of `elem` depending on if `v` was
* provided.
* @param {...*} var_args
*/
lt.util.dom.scroll_top = (function() { 
var scroll_top__delegate = function (elem,p__4956){var vec__4958 = p__4956;var v = cljs.core.nth.call(null,vec__4958,0,null);if(cljs.core.not.call(null,v))
{return elem.scrollTop;
} else
{return elem.scrollTop = v;
}
};
var scroll_top = function (elem,var_args){
var p__4956 = null;if (arguments.length > 1) {
  p__4956 = cljs.core.array_seq(Array.prototype.slice.call(arguments, 1),0);} 
return scroll_top__delegate.call(this,elem,p__4956);};
scroll_top.cljs$lang$maxFixedArity = 1;
scroll_top.cljs$lang$applyTo = (function (arglist__4959){
var elem = cljs.core.first(arglist__4959);
var p__4956 = cljs.core.rest(arglist__4959);
return scroll_top__delegate(elem,p__4956);
});
scroll_top.cljs$core$IFn$_invoke$arity$variadic = scroll_top__delegate;
return scroll_top;
})()
;
/**
* Return the `:top` style of `elem`.
*/
lt.util.dom.top = (function top(elem){return lt.util.dom.css.call(null,elem,new cljs.core.Keyword(null,"top","top",1014019271));
});
/**
* Return the `:bottom` style of `elem`.
*/
lt.util.dom.bottom = (function bottom(elem){return lt.util.dom.css.call(null,elem,new cljs.core.Keyword(null,"bottom","bottom",3925642653));
});
/**
* Return the `:left` style of `elem`.
*/
lt.util.dom.left = (function left(elem){return lt.util.dom.css.call(null,elem,new cljs.core.Keyword(null,"left","left",1017222009));
});
/**
* Return the `:right` style of `elem`.
*/
lt.util.dom.right = (function right(elem){return lt.util.dom.css.call(null,elem,new cljs.core.Keyword(null,"right","right",1122416014));
});
/**
* Return the inner HTML of `elem` or set the inner HTML to `h`.
* @param {...*} var_args
*/
lt.util.dom.html = (function() { 
var html__delegate = function (elem,p__4960){var vec__4962 = p__4960;var h = cljs.core.nth.call(null,vec__4962,0,null);if(cljs.core.not.call(null,h))
{return elem.innerHTML;
} else
{return elem.innerHTML = h;
}
};
var html = function (elem,var_args){
var p__4960 = null;if (arguments.length > 1) {
  p__4960 = cljs.core.array_seq(Array.prototype.slice.call(arguments, 1),0);} 
return html__delegate.call(this,elem,p__4960);};
html.cljs$lang$maxFixedArity = 1;
html.cljs$lang$applyTo = (function (arglist__4963){
var elem = cljs.core.first(arglist__4963);
var p__4960 = cljs.core.rest(arglist__4963);
return html__delegate(elem,p__4960);
});
html.cljs$core$IFn$_invoke$arity$variadic = html__delegate;
return html;
})()
;
/**
* Convert `ev` to string.
*/
lt.util.dom.__GT_ev = (function __GT_ev(ev){return [cljs.core.str(cljs.core.name.call(null,ev))].join('');
});
/**
* Trigger a HTMLEvents event named `ev` on `elem` with `opts` set on the
* event.
* @param {...*} var_args
*/
lt.util.dom.trigger = (function() { 
var trigger__delegate = function (elem,ev,p__4964){var vec__4966 = p__4964;var opts = cljs.core.nth.call(null,vec__4966,0,null);var e = document.createEvent("HTMLEvents");e.initEvent(cljs.core.name.call(null,ev),true,true);
e.opts = opts;
return elem.dispatchEvent(e);
};
var trigger = function (elem,ev,var_args){
var p__4964 = null;if (arguments.length > 2) {
  p__4964 = cljs.core.array_seq(Array.prototype.slice.call(arguments, 2),0);} 
return trigger__delegate.call(this,elem,ev,p__4964);};
trigger.cljs$lang$maxFixedArity = 2;
trigger.cljs$lang$applyTo = (function (arglist__4967){
var elem = cljs.core.first(arglist__4967);
arglist__4967 = cljs.core.next(arglist__4967);
var ev = cljs.core.first(arglist__4967);
var p__4964 = cljs.core.rest(arglist__4967);
return trigger__delegate(elem,ev,p__4964);
});
trigger.cljs$core$IFn$_invoke$arity$variadic = trigger__delegate;
return trigger;
})()
;
/**
* Add event listener named `ev` on `elem` with callback function `cb`.
*/
lt.util.dom.on = (function on(elem,ev,cb){return elem.addEventListener(lt.util.dom.__GT_ev.call(null,ev),cb);
});
/**
* Remove event listener named `ev` on `elem` with callback function `cb`.
*/
lt.util.dom.off = (function off(elem,ev,cb){return elem.removeEventListener(lt.util.dom.__GT_ev.call(null,ev),cb);
});
/**
* Add multiple event listeners to `elem`.
* 
* `evs` should be a map of the form `{:ev cb}` where `:ev` is the name and
* `cb` the callback function.
*/
lt.util.dom.on_STAR_ = (function on_STAR_(elem,evs){var seq__4974 = cljs.core.seq.call(null,evs);var chunk__4975 = null;var count__4976 = 0;var i__4977 = 0;while(true){
if((i__4977 < count__4976))
{var vec__4978 = cljs.core._nth.call(null,chunk__4975,i__4977);var ev = cljs.core.nth.call(null,vec__4978,0,null);var cb = cljs.core.nth.call(null,vec__4978,1,null);elem.addEventListener(lt.util.dom.__GT_ev.call(null,ev),cb);
{
var G__4980 = seq__4974;
var G__4981 = chunk__4975;
var G__4982 = count__4976;
var G__4983 = (i__4977 + 1);
seq__4974 = G__4980;
chunk__4975 = G__4981;
count__4976 = G__4982;
i__4977 = G__4983;
continue;
}
} else
{var temp__4092__auto__ = cljs.core.seq.call(null,seq__4974);if(temp__4092__auto__)
{var seq__4974__$1 = temp__4092__auto__;if(cljs.core.chunked_seq_QMARK_.call(null,seq__4974__$1))
{var c__4263__auto__ = cljs.core.chunk_first.call(null,seq__4974__$1);{
var G__4984 = cljs.core.chunk_rest.call(null,seq__4974__$1);
var G__4985 = c__4263__auto__;
var G__4986 = cljs.core.count.call(null,c__4263__auto__);
var G__4987 = 0;
seq__4974 = G__4984;
chunk__4975 = G__4985;
count__4976 = G__4986;
i__4977 = G__4987;
continue;
}
} else
{var vec__4979 = cljs.core.first.call(null,seq__4974__$1);var ev = cljs.core.nth.call(null,vec__4979,0,null);var cb = cljs.core.nth.call(null,vec__4979,1,null);elem.addEventListener(lt.util.dom.__GT_ev.call(null,ev),cb);
{
var G__4988 = cljs.core.next.call(null,seq__4974__$1);
var G__4989 = null;
var G__4990 = 0;
var G__4991 = 0;
seq__4974 = G__4988;
chunk__4975 = G__4989;
count__4976 = G__4990;
i__4977 = G__4991;
continue;
}
}
} else
{return null;
}
}
break;
}
});
/**
* Return the active element of the document.
* 
* An active element does not necessarily have focus, but an element with focus
* is always the active element in a document.
*/
lt.util.dom.active_element = (function active_element(){return document.activeElement;
});
/**
* Sets focus on `elem`.
*/
lt.util.dom.focus = (function focus(elem){return elem.focus();
});
/**
* Remove focus from `elem`.
*/
lt.util.dom.blur = (function blur(elem){return elem.blur();
});
/**
* Set the current selection range on `elem` with `start` and `stop` being the
* indexes which respectively contain the first and last characters of the
* selection.
* 
* `dir` can be used to set the direction in which selection occurs.
*/
lt.util.dom.selection = (function selection(elem,start,stop,dir){return elem.setSelectionRange(start,stop,dir);
});
/**
* Create div containing `str` as inner HTML. Returns HTMLCollection of
* resulting div.
* 
* See [[children]].
*/
lt.util.dom.make = (function make(str){var d = document.createElement("div");lt.util.dom.html.call(null,d,str);
return lt.util.dom.children.call(null,d);
});
/**
* Returns the index of element `e`, which is where `e` is located inside of its
* parent's list of children, or -1 if there is no parent.
*/
lt.util.dom.index = (function index(e){var p = lt.util.dom.parent.call(null,e);var c = (cljs.core.truth_(p)?lt.util.dom.children.call(null,p):[]);var len = c.length;if(cljs.core.not.call(null,p))
{return -1;
} else
{var i = 0;while(true){
if((i >= len))
{return null;
} else
{if(cljs.core._EQ_.call(null,(c[i]),e))
{return i;
} else
{{
var G__4992 = (i + 1);
i = G__4992;
continue;
}
}
}
break;
}
}
});
/**
* Trigger `func` when `:DOMContentLoaded` fires on the document.
*/
lt.util.dom.ready = (function ready(func){return lt.util.dom.on.call(null,document,new cljs.core.Keyword(null,"DOMContentLoaded","DOMContentLoaded",3783578446),func);
});
/**
* Create and return a document fragment with `items` appended to it as
* children.
*/
lt.util.dom.fragment = (function fragment(items){var frag = document.createDocumentFragment();var seq__4997_5001 = cljs.core.seq.call(null,items);var chunk__4998_5002 = null;var count__4999_5003 = 0;var i__5000_5004 = 0;while(true){
if((i__5000_5004 < count__4999_5003))
{var i_5005 = cljs.core._nth.call(null,chunk__4998_5002,i__5000_5004);frag.appendChild(i_5005);
{
var G__5006 = seq__4997_5001;
var G__5007 = chunk__4998_5002;
var G__5008 = count__4999_5003;
var G__5009 = (i__5000_5004 + 1);
seq__4997_5001 = G__5006;
chunk__4998_5002 = G__5007;
count__4999_5003 = G__5008;
i__5000_5004 = G__5009;
continue;
}
} else
{var temp__4092__auto___5010 = cljs.core.seq.call(null,seq__4997_5001);if(temp__4092__auto___5010)
{var seq__4997_5011__$1 = temp__4092__auto___5010;if(cljs.core.chunked_seq_QMARK_.call(null,seq__4997_5011__$1))
{var c__4263__auto___5012 = cljs.core.chunk_first.call(null,seq__4997_5011__$1);{
var G__5013 = cljs.core.chunk_rest.call(null,seq__4997_5011__$1);
var G__5014 = c__4263__auto___5012;
var G__5015 = cljs.core.count.call(null,c__4263__auto___5012);
var G__5016 = 0;
seq__4997_5001 = G__5013;
chunk__4998_5002 = G__5014;
count__4999_5003 = G__5015;
i__5000_5004 = G__5016;
continue;
}
} else
{var i_5017 = cljs.core.first.call(null,seq__4997_5011__$1);frag.appendChild(i_5017);
{
var G__5018 = cljs.core.next.call(null,seq__4997_5011__$1);
var G__5019 = null;
var G__5020 = 0;
var G__5021 = 0;
seq__4997_5001 = G__5018;
chunk__4998_5002 = G__5019;
count__4999_5003 = G__5020;
i__5000_5004 = G__5021;
continue;
}
}
} else
{}
}
break;
}
return frag;
});
